var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, Inject, Input, Output, EventEmitter } from '@angular/core';
import { AccordionComponent } from './accordion.component';
var AccordionItemComponent = (function () {
    function AccordionItemComponent(accordion) {
        this.isOpenChange = new EventEmitter();
        this._isOpen = false;
        this.accordion = accordion;
    }
    Object.defineProperty(AccordionItemComponent.prototype, "isOpen", {
        get: function () {
            return this._isOpen;
        },
        set: function (value) {
            var _this = this;
            if (value !== this.isOpen) {
                if (value) {
                    this.accordion.closeOtherPanels(this);
                }
                this._isOpen = value;
                Promise.resolve(null).then(function () {
                    _this.isOpenChange.emit(value);
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    AccordionItemComponent.prototype.ngOnInit = function () {
        this.accordion.addGroup(this);
    };
    AccordionItemComponent.prototype.ngOnDestroy = function () {
        this.accordion.removeGroup(this);
    };
    AccordionItemComponent.prototype.toggleOpen = function (event) {
        if (!this.isDisabled) {
            this.isOpen = !this.isOpen;
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AccordionItemComponent.prototype, "header", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AccordionItemComponent.prototype, "isDisabled", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], AccordionItemComponent.prototype, "isOpenChange", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], AccordionItemComponent.prototype, "isOpen", null);
    AccordionItemComponent = __decorate([
        Component({
            selector: 'hi-accordion-item',
            template: "\n    <div class=\"card\"><div class=\"card-header\" role=\"tab\" (click)=\"toggleOpen($event)\"><div role=\"button\" class=\"accordion-toggle\"><div *ngIf=\"header\" [ngClass]=\"{'text-muted': isDisabled}\">{{ header }}</div><ng-content select=\"[hi-accordion-header]\"></ng-content></div></div><div class=\"collapse\" role=\"tabpanel\" [ngClass]=\"{show: isOpen}\"><div class=\"card-block card-body\"><ng-content></ng-content><ng-content select=\"[hi-accordion-body]\"></ng-content></div></div></div>\n  ",
            exportAs: 'accordionItem'
        }),
        __param(0, Inject(AccordionComponent)),
        __metadata("design:paramtypes", [AccordionComponent])
    ], AccordionItemComponent);
    return AccordionItemComponent;
}());
export { AccordionItemComponent };
