var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, EventEmitter, HostListener, Output, TemplateRef, ElementRef } from '@angular/core';
import { trigger, state, style, animate, transition } from '@angular/animations';
var ActionButtonComponent = (function () {
    function ActionButtonComponent(elementRef) {
        this.elementRef = elementRef;
        this.type = 'default';
        this.direction = 'down';
        this.disabled = false;
        this.actionClick = new EventEmitter();
        this.openStatusChange = new EventEmitter();
        this.animateState = 'initial';
        this.isOpen = false;
    }
    ActionButtonComponent.prototype.toggle = function () {
        if (!this.isOpen) {
            this.show();
        }
        else {
            this.hide();
        }
        this.openStatusChange.emit(this.isOpen);
    };
    ActionButtonComponent.prototype.afterVisibilityAnimation = function (e) {
        if (e.toState === 'hidden' && this.isOpen) {
            this.isOpen = false;
        }
    };
    ActionButtonComponent.prototype.onDocumentClick = function ($event) {
        if (!this.elementRef.nativeElement.contains($event.target)) {
            this.close();
        }
    };
    ActionButtonComponent.prototype.close = function () {
        if (this.isOpen) {
            this.hide();
            this.openStatusChange.emit(this.isOpen);
        }
    };
    ActionButtonComponent.prototype.onActionClick = function (item) {
        if (!item.disabled) {
            this.close();
            this.actionClick.emit(item);
        }
    };
    ActionButtonComponent.prototype.show = function () {
        this.isOpen = true;
        this.animateState = 'visible';
    };
    ActionButtonComponent.prototype.hide = function () {
        this.animateState = 'hidden';
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ActionButtonComponent.prototype, "type", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ActionButtonComponent.prototype, "direction", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ActionButtonComponent.prototype, "icon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ActionButtonComponent.prototype, "btnSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ActionButtonComponent.prototype, "buttonText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ActionButtonComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], ActionButtonComponent.prototype, "actions", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ActionButtonComponent.prototype, "disabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], ActionButtonComponent.prototype, "buttonTemplate", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ActionButtonComponent.prototype, "actionClick", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ActionButtonComponent.prototype, "openStatusChange", void 0);
    __decorate([
        HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], ActionButtonComponent.prototype, "onDocumentClick", null);
    ActionButtonComponent = __decorate([
        Component({
            selector: 'hi-action-button',
            template: "\n    <ng-template #defaultButtonTemplate let-action><button class=\"btn {{action.type? 'btn-' + action.type : ''}} {{action.btnSize? 'btn-' + action.btnSize : ''}}\" (click)=\"action.toggle($event)\" [disabled]=\"action.disabled\"><i *ngIf=\"action.icon\" class=\"{{action.icon}}\" aria-hidden=\"true\"></i> {{action.buttonText}}</button> <button type=\"button\" class=\"btn {{action.type? 'btn-' + action.type : ''}} {{action.btnSize? 'btn-' + action.btnSize : ''}} dropdown-toggle\" aria-haspopup=\"true\" [attr.aria-expanded]=\"true\" (click)=\"action.toggle()\" [disabled]=\"action.disabled\"><span class=\"caret\"></span> <span class=\"sr-only\">|</span></button></ng-template><div class=\"btn-group {{direction? 'drop' + direction : '' }} {{cssClass}}\" [ngClass]=\"{open: isOpen}\"><ng-template [ngTemplateOutlet]=\"buttonTemplate || defaultButtonTemplate\" [ngTemplateOutletContext]=\"{ $implicit: this}\"></ng-template><ul class=\"dropdown-menu\" role=\"menu\" [@state]=\"animateState\" (@state.done)=\"afterVisibilityAnimation($event)\"><ng-container *ngFor=\"let item of actions\"><li *ngIf=\"!item.divider && ! item.header\" role=\"menuitem\" [ngClass]=\"{'disabled': item.disabled}\" (click)=\"onActionClick(item)\" class=\"dropdown-item\"><a><i *ngIf=\"item.icon\" class=\"{{item.icon}}\"></i>&nbsp;{{item.text}}</a></li><li *ngIf=\"item.header\" class=\"dropdown-header\">{{item.text}}</li><li *ngIf=\"item.divider\" class=\"divider\" role=\"separator\"></li></ng-container></ul></div>\n  ",
            exportAs: 'actionButton',
            animations: [
                trigger('state', [
                    state('void', style({ transform: 'scale(0)' })),
                    state('initial', style({ transform: 'scale(0)' })),
                    state('visible', style({ transform: 'scale(1)' })),
                    state('hidden', style({ transform: 'scale(0)' })),
                    transition('* => visible', animate('150ms cubic-bezier(0.0, 0.0, 0.2, 1)')),
                    transition('* => hidden', animate('150ms cubic-bezier(0.4, 0.0, 1, 1)')),
                ])
            ]
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], ActionButtonComponent);
    return ActionButtonComponent;
}());
export { ActionButtonComponent };
