var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ChangeDetectionStrategy } from '@angular/core';
import { HiNGConfig } from '../hi.config';
var AlertBoxComponent = (function () {
    function AlertBoxComponent(hiNGConfig) {
        this.type = 'info';
        this.close = new EventEmitter();
        this.type = hiNGConfig.alertBox.type;
        this.closable = hiNGConfig.alertBox.closable;
    }
    AlertBoxComponent.prototype.closeBox = function () {
        this.onCloseBox();
    };
    AlertBoxComponent.prototype.onCloseBox = function () {
        this.close.emit(this);
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AlertBoxComponent.prototype, "type", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AlertBoxComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AlertBoxComponent.prototype, "closable", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], AlertBoxComponent.prototype, "close", void 0);
    AlertBoxComponent = __decorate([
        Component({
            selector: 'hi-alert-box',
            template: "\n    <div class=\"alert alert-{{type}} {{cssClass}}\" [ngClass]=\"{'alert-dismissible': closable}\" role=\"alert\"><div class=\"close\" data-dismiss=\"alert\" aria-label=\"Close\" *ngIf=\"closable\"><span aria-hidden=\"true\" (click)=\"closeBox()\">&times;</span></div><ng-content></ng-content></div>\n  ",
            exportAs: 'alertBox',
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        __metadata("design:paramtypes", [HiNGConfig])
    ], AlertBoxComponent);
    return AlertBoxComponent;
}());
export { AlertBoxComponent };
