var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ChangeDetectorRef, Component, forwardRef, Input, TemplateRef, ViewChild } from '@angular/core';
import { AutoCompleteDirective } from './auto-complete.directive';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { HiNGConfig } from '../hi.config';
var MutipleAutoCompleteComponent = (function () {
    function MutipleAutoCompleteComponent(hiNGConfig, changeDetectorRef) {
        this.hiNGConfig = hiNGConfig;
        this.changeDetectorRef = changeDetectorRef;
        this.appendBody = false;
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.delay = hiNGConfig.autoComplete.delay;
        this.minLength = hiNGConfig.autoComplete.minLength;
        this.itemTemplate = hiNGConfig.autoComplete.itemTemplate;
        this.noResultItemTemplate = hiNGConfig.autoComplete.noResultItemTemplate;
        this.formatter = hiNGConfig.autoComplete.formatter;
        this.valueParser = hiNGConfig.autoComplete.valueParser;
        this.id = MutipleAutoCompleteComponent_1.ID_SEED++;
    }
    MutipleAutoCompleteComponent_1 = MutipleAutoCompleteComponent;
    MutipleAutoCompleteComponent.prototype.writeValue = function (obj) {
        this.mutipleItems = obj || [];
        this.changeDetectorRef.markForCheck();
    };
    MutipleAutoCompleteComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    MutipleAutoCompleteComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    MutipleAutoCompleteComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    MutipleAutoCompleteComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.autoCompleteDirective) {
            this.autoCompleteDirective.registerOnTouched(function () { return _this.onTouched(); });
        }
    };
    MutipleAutoCompleteComponent.prototype.toggle = function ($event) {
        if (this.autoCompleteDirective) {
            this.autoCompleteDirective.toggle($event);
        }
    };
    MutipleAutoCompleteComponent.prototype.onMutipleSearch = function () {
        this.onTouched();
        if (this.mutipleItems.indexOf(this.selectValue) === -1) {
            this.mutipleItems.push(this.selectValue);
            this.onChange(this.mutipleItems);
        }
        this.selectValue = null;
    };
    MutipleAutoCompleteComponent.prototype.removeLabel = function (label) {
        if (this.disabled) {
            return;
        }
        this.onTouched();
        if (this.mutipleItems.indexOf(label) !== -1) {
            this.mutipleItems = this.mutipleItems.filter(function (item) { return item !== label; });
            this.onChange(this.mutipleItems);
        }
    };
    MutipleAutoCompleteComponent.prototype.onMutipleSearchBoxBackspace = function ($event) {
        var _this = this;
        this.onTouched();
        if (!$event.target.value && this.mutipleItems.length) {
            this.mutipleItems.pop();
            this.onChange(this.mutipleItems);
            setTimeout(function () { return _this.autoCompleteDirective.positionPopup(); }, 0);
        }
    };
    var MutipleAutoCompleteComponent_1;
    MutipleAutoCompleteComponent.ID_SEED = 0;
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], MutipleAutoCompleteComponent.prototype, "disabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], MutipleAutoCompleteComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], MutipleAutoCompleteComponent.prototype, "popupCssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MutipleAutoCompleteComponent.prototype, "delay", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MutipleAutoCompleteComponent.prototype, "minLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], MutipleAutoCompleteComponent.prototype, "appendBody", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], MutipleAutoCompleteComponent.prototype, "dataSource", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], MutipleAutoCompleteComponent.prototype, "itemTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], MutipleAutoCompleteComponent.prototype, "noResultItemTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], MutipleAutoCompleteComponent.prototype, "formatter", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], MutipleAutoCompleteComponent.prototype, "valueParser", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], MutipleAutoCompleteComponent.prototype, "onSearch", void 0);
    __decorate([
        ViewChild(AutoCompleteDirective, { static: false }),
        __metadata("design:type", AutoCompleteDirective)
    ], MutipleAutoCompleteComponent.prototype, "autoCompleteDirective", void 0);
    MutipleAutoCompleteComponent = MutipleAutoCompleteComponent_1 = __decorate([
        Component({
            selector: 'hi-mutiple-auto-complete',
            template: "\n    <label for=\"mutiple-label-auto-complete-{{id}}\" class=\"mutiple-label-auto-complete {{cssClass}}\"><ul><li *ngFor=\"let item of mutipleItems\"><span class=\"label label-info\" [ngClass]=\"{disabled: disabled}\"><i aria-hidden=\"true\" class=\"label-close\" (click)=\"removeLabel(item)\">&times;</i>{{formatter(item)}}</span></li><li *ngIf=\"!disabled\"><input id=\"mutiple-label-auto-complete-{{id}}\" name=\"mutipleAutoComplete\" class=\"auto-complete-control\" [(ngModel)]=\"selectValue\" (selectValueChange)=\"onMutipleSearch()\" [onSearch]=\"onSearch\" [cssClass]=\"popupCssClass\" [delay]=\"delay\" [minLength]=\"minLength\" [itemTemplate]=\"itemTemplate\" [noResultItemTemplate]=\"noResultItemTemplate\" [formatter]=\"formatter\" [valueParser]=\"valueParser\" (keydown.backspace)=\"onMutipleSearchBoxBackspace($event)\" [disabled]=\"disabled\" [dataSource]=\"dataSource\" [appendBody]=\"appendBody\" reAutoComplete></li></ul></label>\n  ",
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return MutipleAutoCompleteComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [HiNGConfig, ChangeDetectorRef])
    ], MutipleAutoCompleteComponent);
    return MutipleAutoCompleteComponent;
}());
export { MutipleAutoCompleteComponent };
