import { QueryList, EventEmitter, AfterContentInit, OnDestroy, Renderer2, ElementRef } from '@angular/core';
import { SlideDirective } from './slide.directive';
import { HiNGConfig } from '../hi.config';
export declare enum CarouselDirection {
    NEXT = 0,
    PREV = 1
}
export declare class CarouselComponent implements AfterContentInit, OnDestroy {
    private renderer;
    private hiNGConfig;
    activeSlide: number;
    interval: number;
    animate: boolean;
    activeSlideChange: EventEmitter<number>;
    slides: QueryList<SlideDirective>;
    slideItems: QueryList<ElementRef>;
    intervalId: any;
    reflowDuration: number;
    animationDuration: number;
    constructor(renderer: Renderer2, hiNGConfig: HiNGConfig);
    ngAfterContentInit(): void;
    selectSlide(index: any): void;
    selectPrevSlide($event?: Event): void;
    selectNextSlide($event?: Event): void;
    onActiveSlideChange(index: any, carouselDirection: CarouselDirection): void;
    pauseInterval(): void;
    startInterval(): void;
    ngOnDestroy(): void;
    private slideAnimation;
    private stopInterval;
}
