var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input, ChangeDetectorRef, forwardRef, Output, EventEmitter } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
var CheckboxComponent = (function () {
    function CheckboxComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.disabled = false;
        this.checkedValue = true;
        this.unCheckedValue = false;
        this.valueChange = new EventEmitter();
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
    }
    CheckboxComponent_1 = CheckboxComponent;
    CheckboxComponent.prototype.writeValue = function (obj) {
        this.value = obj;
        this.changeDetectorRef.markForCheck();
    };
    CheckboxComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    CheckboxComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    CheckboxComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    CheckboxComponent.prototype.onCheckBoxChange = function (checkbox) {
        this.onTouched();
        if (checkbox.checked) {
            this.value = this.checkedValue;
        }
        else {
            this.value = this.unCheckedValue;
        }
        this.onChange(this.value);
        this.valueChange.emit(this.value);
    };
    CheckboxComponent.prototype.isChecked = function () {
        return this.value === this.checkedValue;
    };
    var CheckboxComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CheckboxComponent.prototype, "disabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CheckboxComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CheckboxComponent.prototype, "label", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CheckboxComponent.prototype, "checkedValue", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CheckboxComponent.prototype, "unCheckedValue", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], CheckboxComponent.prototype, "valueChange", void 0);
    CheckboxComponent = CheckboxComponent_1 = __decorate([
        Component({
            selector: 'hi-checkbox',
            template: "\n    <label><input #checkbox type=\"checkbox\" [checked]=\"isChecked()\" [disabled]=\"disabled\" (change)=\"onCheckBoxChange(checkbox)\">{{label}}</label>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            exportAs: 'checkbox',
            host: { '[class]': '(cssClass ? cssClass : "") + " checkbox"' },
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return CheckboxComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [ChangeDetectorRef])
    ], CheckboxComponent);
    return CheckboxComponent;
}());
export { CheckboxComponent };
