var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, HostListener, Output, Input, EventEmitter, Renderer2, ElementRef } from '@angular/core';
var DropdownDirective = (function () {
    function DropdownDirective(elementRef, renderer) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.active = false;
        this.dropdownStatusChange = new EventEmitter();
        this.activeCss = 'open';
    }
    DropdownDirective.prototype.onDocumentClick = function ($event) {
        if (!this.elementRef.nativeElement.contains($event.target)) {
            this.active = false;
            this.updateHostStatus();
        }
    };
    DropdownDirective.prototype.onHostClick = function () {
        this.toggle();
    };
    DropdownDirective.prototype.toggle = function () {
        this.active = !this.active;
        this.updateHostStatus();
    };
    DropdownDirective.prototype.updateHostStatus = function () {
        this.dropdownStatusChange.emit(this.active);
        if (this.active) {
            this.renderer.addClass(this.elementRef.nativeElement, this.activeCss);
            return;
        }
        this.renderer.removeClass(this.elementRef.nativeElement, this.activeCss);
    };
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DropdownDirective.prototype, "dropdownStatusChange", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DropdownDirective.prototype, "activeCss", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DropdownDirective.prototype, "direction", void 0);
    __decorate([
        HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DropdownDirective.prototype, "onDocumentClick", null);
    __decorate([
        HostListener('click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], DropdownDirective.prototype, "onHostClick", null);
    DropdownDirective = __decorate([
        Directive({
            selector: '[hiDropdown]',
            host: {
                '[class.dropdown]': 'direction !== "up"',
                '[class.dropup]': 'direction === "up"'
            },
            exportAs: 'dropdown'
        }),
        __metadata("design:paramtypes", [ElementRef, Renderer2])
    ], DropdownDirective);
    return DropdownDirective;
}());
export { DropdownDirective };
