var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { DocumentRef } from '../../window-ref/document-ref.service';
var AssetsLoader = (function () {
    function AssetsLoader(documentRef) {
        this.documentRef = documentRef;
        this.resources = {};
    }
    AssetsLoader.prototype.createScript = function (src) {
        var _this = this;
        if (this.resources[src]) {
            return this.resources[src];
        }
        var promise = new Promise(function (resolve, reject) {
            var script = _this.documentRef.createElement('script');
            script.type = 'text/javascript';
            script.src = src;
            script.async = true;
            script.charset = 'UTF-8';
            script.id = "hi_script_" + src;
            script.onreadystatechange = script.onload = function () {
                if ((!script.readyState || /loaded|complete/.test(script.readyState))) {
                    resolve(script);
                }
            };
            script.onerror = function (e) {
                reject(e);
            };
            _this.documentRef.body.appendChild(script);
        });
        this.resources[src] = promise;
        return promise;
    };
    AssetsLoader.prototype.createStyle = function (src) {
        var _this = this;
        if (this.resources[src]) {
            return this.resources[src];
        }
        var promise = new Promise(function (resolve, reject) {
            var link = _this.documentRef.createElement('link');
            link.rel = 'stylesheet';
            link.href = src;
            link.type = 'text/css';
            link.charset = 'UTF-8';
            link.id = "hi_link_" + src;
            link.onreadystatechange = link.onload = function () {
                resolve(link);
            };
            link.onerror = function (e) {
                reject(e);
            };
            _this.documentRef.body.appendChild(link);
        });
        this.resources[src] = promise;
        return promise;
    };
    AssetsLoader = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [DocumentRef])
    ], AssetsLoader);
    return AssetsLoader;
}());
export { AssetsLoader };
