var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, ComponentFactoryResolver } from '@angular/core';
import { ModalService } from '../modal/modal.service';
import { AlertDialogComponent } from './alert-dialog.component';
import { ConfirmDialogComponent } from './confirm-dialog.component';
import { DomSanitizer } from '@angular/platform-browser';
import { PromptDialogComponent } from './prompt-dialog.component';
var DialogService = (function () {
    function DialogService(modalService, componentFactoryResolver, domSanitizer) {
        this.modalService = modalService;
        this.componentFactoryResolver = componentFactoryResolver;
        this.domSanitizer = domSanitizer;
    }
    DialogService.prototype.alert = function (dialogOptions) {
        if (dialogOptions.content && dialogOptions.html && (typeof dialogOptions.content === 'string')) {
            dialogOptions.content = this.domSanitizer.bypassSecurityTrustHtml(dialogOptions.content);
        }
        return this.modalService.open({
            component: AlertDialogComponent,
            componentFactoryResolver: this.componentFactoryResolver,
            resolve: dialogOptions,
            modalClass: dialogOptions.cssClass,
            injector: dialogOptions.injector,
            rootContainer: dialogOptions.rootContainer,
            backdrop: dialogOptions.backdrop,
            backdropClass: dialogOptions.backdropClass,
            modal: dialogOptions.modal,
            keyboard: dialogOptions.keyboard,
            animation: dialogOptions.animation
        });
    };
    DialogService.prototype.confirm = function (dialogOptions) {
        if (dialogOptions.content && dialogOptions.html && (typeof dialogOptions.content === 'string')) {
            dialogOptions.content = this.domSanitizer.bypassSecurityTrustHtml(dialogOptions.content);
        }
        return this.modalService.open({
            component: ConfirmDialogComponent,
            componentFactoryResolver: this.componentFactoryResolver,
            resolve: dialogOptions,
            modalClass: dialogOptions.cssClass,
            injector: dialogOptions.injector,
            rootContainer: dialogOptions.rootContainer,
            backdrop: dialogOptions.backdrop,
            backdropClass: dialogOptions.backdropClass,
            modal: dialogOptions.modal,
            keyboard: dialogOptions.keyboard,
            animation: dialogOptions.animation
        });
    };
    DialogService.prototype.prompt = function (dialogOptions) {
        return this.modalService.open({
            component: PromptDialogComponent,
            componentFactoryResolver: this.componentFactoryResolver,
            resolve: dialogOptions,
            modalClass: dialogOptions.cssClass,
            injector: dialogOptions.injector,
            rootContainer: dialogOptions.rootContainer,
            backdrop: dialogOptions.backdrop,
            backdropClass: dialogOptions.backdropClass,
            modal: dialogOptions.modal,
            keyboard: dialogOptions.keyboard,
            animation: dialogOptions.animation
        });
    };
    DialogService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [ModalService,
            ComponentFactoryResolver,
            DomSanitizer])
    ], DialogService);
    return DialogService;
}());
export { DialogService };
