var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, TemplateRef, ViewChild, ChangeDetectorRef } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ModalDismissReasons } from '../modal';
import { HiNGConfig } from '../hi.config';
var PromptDialogComponent = (function () {
    function PromptDialogComponent(hiNGConfig, formBuilder, changeDetectorRef) {
        this.hiNGConfig = hiNGConfig;
        this.formBuilder = formBuilder;
        this.changeDetectorRef = changeDetectorRef;
        this.btnYes = hiNGConfig.dialog.button.yes;
        this.btnYesType = hiNGConfig.dialog.button.btnYesType;
        this.btnNo = hiNGConfig.dialog.button.no;
        this.btnNoType = hiNGConfig.dialog.button.btnNoType;
    }
    PromptDialogComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.content = this.context.content;
        this.validators = this.content.validators || {};
        var validatorFns = Object.keys(this.validators).map(function (key) { return _this.validators[key].validator; });
        this.form = this.formBuilder.group({
            promptValue: [this.content.defaultValue || '', validatorFns]
        });
        this.form.valueChanges.subscribe(function () {
            _this.changeDetectorRef.markForCheck();
        });
    };
    PromptDialogComponent.prototype.getFieldErrors = function (control) {
        if (control && control.errors) {
            var errors = Object.keys(control.errors).filter(function (key) { return control.errors[key]; });
            return errors.length > 0 ? [errors[0]] : [];
        }
    };
    PromptDialogComponent.prototype.yes = function () {
        this.dismiss.emit(__assign({}, this.form.value, { type: ModalDismissReasons.YES }));
    };
    PromptDialogComponent.prototype.no = function () {
        this.dismiss.error(ModalDismissReasons.NO);
    };
    __decorate([
        ViewChild('defaultTemplate', { static: false }),
        __metadata("design:type", TemplateRef)
    ], PromptDialogComponent.prototype, "defaultTemplate", void 0);
    PromptDialogComponent = __decorate([
        Component({
            selector: 'hi-prompt',
            template: "\n    <div class=\"modal-header\"><button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"no()\"><span aria-hidden=\"true\">&times;</span></button><h4 class=\"modal-title\">{{context.title}}</h4></div><div class=\"modal-body\"><form [formGroup]=\"form\" novalidate><div class=\"form-group\" [class.has-error]=\"form.controls.promptValue.touched && form.controls.promptValue.invalid\"><label for=\"promptValue\" class=\"control-label\">{{content?.label}}</label><ng-template [ngTemplateOutlet]=\"content.template || defaultTemplate\" [ngTemplateOutletContext]=\"{ $implicit: this, option: context, formGroup:form }\"></ng-template><ng-container *ngIf=\"form.controls.promptValue.touched\"><div class=\"help-block\" *ngFor=\"let key of getFieldErrors(form.controls.promptValue)\">{{validators[key]?.message}}</div></ng-container></div></form></div><div class=\"modal-footer\"><button type=\"button\" [disabled]=\"form.untouched || form.invalid\" class=\"btn btn-{{btnYesType}}\" (click)=\"yes()\">{{context.yes ||btnYes}}</button> <button type=\"button\" class=\"btn btn-{{btnNoType}}\" (click)=\"no()\">{{context.no || btnNo}}</button></div><ng-template #defaultTemplate let-option=\"option\" let-formGroup=\"formGroup\"><input class=\"form-control\" id=\"promptValue\" name=\"promptValue\" [formControl]=\"formGroup.controls.promptValue\" [placeholder]=\"option.content?.placeholder\"></ng-template>\n  "
        }),
        __metadata("design:paramtypes", [HiNGConfig,
            FormBuilder,
            ChangeDetectorRef])
    ], PromptDialogComponent);
    return PromptDialogComponent;
}());
export { PromptDialogComponent };
