var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { HostListener, EventEmitter, Output, Input, Directive, ContentChild, ElementRef } from '@angular/core';
var DraggableHandleDirective = (function () {
    function DraggableHandleDirective(elementRef) {
        this.elementRef = elementRef;
    }
    DraggableHandleDirective = __decorate([
        Directive({
            selector: '[reDraggableHandle]'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], DraggableHandleDirective);
    return DraggableHandleDirective;
}());
export { DraggableHandleDirective };
var DraggableDirective = (function () {
    function DraggableDirective() {
        this.disabled = false;
        this.dragEffect = 'copy';
        this.onDragStart = new EventEmitter();
        this.onDragEnd = new EventEmitter();
        this.onDragging = new EventEmitter();
    }
    DraggableDirective_1 = DraggableDirective;
    DraggableDirective.prototype.dragStart = function ($event) {
        if (!this.draggableHandle || this.draggableHandle.elementRef.nativeElement === this.handle) {
            $event.stopPropagation();
            $event.dataTransfer.effectAllowed = this.dragEffect;
            $event.dataTransfer.setData(DraggableDirective_1.DRAGGABLE_DATA_KEY, JSON.stringify({
                group: this.group,
                data: this.dragData
            }));
            this.onDragStart.emit($event);
            return;
        }
        $event.preventDefault();
    };
    DraggableDirective.prototype.drag = function ($event) {
        this.onDragging.emit($event);
    };
    DraggableDirective.prototype.dragEnd = function ($event) {
        this.onDragEnd.emit($event);
    };
    DraggableDirective.prototype.mouseover = function (event) {
        this.handle = event.target;
    };
    DraggableDirective.prototype.mouseleave = function (event) {
        this.handle = null;
    };
    var DraggableDirective_1;
    DraggableDirective.DRAGGABLE_DATA_KEY = 'text';
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DraggableDirective.prototype, "disabled", void 0);
    __decorate([
        Input('reDraggable'),
        __metadata("design:type", String)
    ], DraggableDirective.prototype, "group", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DraggableDirective.prototype, "dragData", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DraggableDirective.prototype, "dragEffect", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DraggableDirective.prototype, "onDragStart", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DraggableDirective.prototype, "onDragEnd", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DraggableDirective.prototype, "onDragging", void 0);
    __decorate([
        ContentChild(DraggableHandleDirective, { static: false }),
        __metadata("design:type", DraggableHandleDirective)
    ], DraggableDirective.prototype, "draggableHandle", void 0);
    __decorate([
        HostListener('dragstart', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DraggableDirective.prototype, "dragStart", null);
    __decorate([
        HostListener('drag', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DraggableDirective.prototype, "drag", null);
    __decorate([
        HostListener('dragend', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DraggableDirective.prototype, "dragEnd", null);
    __decorate([
        HostListener('mouseover', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DraggableDirective.prototype, "mouseover", null);
    __decorate([
        HostListener('mouseleave', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DraggableDirective.prototype, "mouseleave", null);
    DraggableDirective = DraggableDirective_1 = __decorate([
        Directive({
            selector: '[reDraggable]',
            host: {
                '[draggable]': '!disabled'
            }
        })
    ], DraggableDirective);
    return DraggableDirective;
}());
export { DraggableDirective };
