var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { HostListener, EventEmitter, Output, Input, Directive } from '@angular/core';
import { DraggableDirective } from './draggable.directive';
var DroppableDirective = (function () {
    function DroppableDirective() {
        this.dropEffect = 'move';
        this.onDragEnter = new EventEmitter();
        this.onDragLeave = new EventEmitter();
        this.onDrop = new EventEmitter();
        this.onDragOver = new EventEmitter();
    }
    DroppableDirective.prototype.drop = function ($event) {
        if ((!this.group || this.isDropGroup($event)) && (!this.acceptDrop || this.acceptDrop($event))) {
            this.startDrop($event);
        }
    };
    DroppableDirective.prototype.dragEnter = function ($event) {
        $event.preventDefault();
        if (this.dropEffect) {
            $event.dataTransfer.dropEffect = this.dropEffect;
        }
        this.onDragEnter.emit($event);
    };
    DroppableDirective.prototype.dragLeave = function ($event) {
        $event.preventDefault();
        this.onDragLeave.emit($event);
    };
    DroppableDirective.prototype.dragOver = function ($event) {
        $event.preventDefault();
        this.onDragOver.emit($event);
    };
    DroppableDirective.prototype.isDropGroup = function ($event) {
        var contextData = $event.dataTransfer.getData(DraggableDirective.DRAGGABLE_DATA_KEY);
        if (contextData) {
            var draggableData = JSON.parse(contextData);
            return this.group === draggableData.group;
        }
    };
    DroppableDirective.prototype.startDrop = function ($event) {
        $event.preventDefault();
        $event.stopPropagation();
        this.onDrop.emit($event);
    };
    __decorate([
        Input('reDroppable'),
        __metadata("design:type", String)
    ], DroppableDirective.prototype, "group", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], DroppableDirective.prototype, "acceptDrop", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DroppableDirective.prototype, "dropEffect", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DroppableDirective.prototype, "onDragEnter", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DroppableDirective.prototype, "onDragLeave", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DroppableDirective.prototype, "onDrop", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DroppableDirective.prototype, "onDragOver", void 0);
    __decorate([
        HostListener('drop', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DroppableDirective.prototype, "drop", null);
    __decorate([
        HostListener('dragenter', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DroppableDirective.prototype, "dragEnter", null);
    __decorate([
        HostListener('dragleave', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DroppableDirective.prototype, "dragLeave", null);
    __decorate([
        HostListener('dragover', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DroppableDirective.prototype, "dragOver", null);
    DroppableDirective = __decorate([
        Directive({
            selector: '[reDroppable]',
        })
    ], DroppableDirective);
    return DroppableDirective;
}());
export { DroppableDirective };
