import { ElementRef, AfterViewInit, Renderer2, EventEmitter, ChangeDetectorRef, TemplateRef } from '@angular/core';
import { SelectFileModel } from './file-upload.model';
import { HiNGConfig } from '../hi.config';
import { HttpClient } from '@angular/common/http';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import { Observable } from 'rxjs/Observable';
export declare class FileUpload implements AfterViewInit {
    protected hiNGConfig: HiNGConfig;
    protected renderer: Renderer2;
    protected http: HttpClient;
    protected changeDetectorRef: ChangeDetectorRef;
    accept: string;
    multiple: boolean;
    autoUpload: boolean;
    showErrors: boolean;
    maxItems: number;
    maxFileSize: number;
    uploadUrl: string;
    uploadParamName: string;
    uploadRequestOptions: any;
    imgPreview: boolean;
    previewWidth: string;
    previewHeight: string;
    cssClass: string;
    fileSizeErrorMessage: string;
    fileTypeErrorMessage: string;
    chooseButton: string;
    uploadButton: string;
    cancelButton: string;
    plusIcon: string;
    uploadIcon: string;
    loadingIcon: string;
    removeIcon: string;
    toolbarTemplate: TemplateRef<any>;
    previewTemplate: TemplateRef<any>;
    selectFilesChange: EventEmitter<SelectFileModel[]>;
    fileUploadStart: EventEmitter<SelectFileModel[]>;
    fileUploadCompleted: EventEmitter<SelectFileModel[]>;
    fileUploadSuccess: EventEmitter<SelectFileModel>;
    fileUploadError: EventEmitter<SelectFileModel>;
    removeFiles: EventEmitter<SelectFileModel[]>;
    uploadFilesChange: EventEmitter<SelectFileModel[]>;
    uploadFiles: SelectFileModel[];
    fileInput: ElementRef;
    selectFiles: SelectFileModel[];
    isUploading: boolean;
    errors: string[];
    constructor(hiNGConfig: HiNGConfig, renderer: Renderer2, http: HttpClient, changeDetectorRef: ChangeDetectorRef);
    ngAfterViewInit(): void;
    isMoreThanMaxItems(): boolean;
    clearErrors(): void;
    onDropFiles($event: any): void;
    addNewFile($event: any): void;
    newFileChoose(fileInput: HTMLInputElement): void;
    removeAllSelectedFiles(): void;
    onRemoveFile(fileItem: any): void;
    onRemoveUploadFile(fileItem: any): void;
    uploadAllFiles(): void;
    httpUploadAllFile(files: any): void;
    httpUploadFile(fileItem: any): Observable<any>;
    protected onFileUploadSuccess(fileItem: any, res: any): Observable<any>;
    protected onFileUploadError(fileItem: any, error: any): Observable<any>;
    private handleFileChoose;
    validFiles(files: File[]): File[];
    validFile(file: File): boolean;
    private getFileCount;
    private validFileType;
    mapFileModel(files: File[]): Promise<SelectFileModel[]>;
}
