import { Bounds } from './model/bounds';
import { CornerMarker } from './model/cornerMarker';
import { CropperTouch } from './model/position';
import { ImageCropperSettings } from './image-cropper.settings';
import { DragMarker } from './model/dragMarker';
import { CropperModel } from './model/cropperModel';
import { Point } from './model/point';
export declare class ImageCropperDataShare {
    static share: any;
    static pressed: HTMLCanvasElement;
    static over: HTMLCanvasElement;
    static setPressed(canvas: HTMLCanvasElement): void;
    static setReleased(canvas: HTMLCanvasElement): void;
    static setOver(canvas: HTMLCanvasElement): void;
    static setStyle(canvas: HTMLCanvasElement, style: any): void;
}
export declare class ImageCropperUtils extends CropperModel {
    private crop;
    private cropperSettings;
    private previousDistance;
    constructor(cropperSettings: ImageCropperSettings);
    private static sign;
    private static getMousePos;
    private static getTouchPos;
    private static detectVerticalSquash;
    private getDataUriMimeType;
    prepare(canvas: HTMLCanvasElement): void;
    resizeCanvas(width: number, height: number, setImage?: boolean): void;
    reset(): void;
    draw(ctx: CanvasRenderingContext2D): void;
    dragCenter(x: number, y: number, marker: DragMarker): void;
    enforceMinSize(x: number, y: number, marker: CornerMarker): Point;
    dragCorner(x: number, y: number, marker: CornerMarker): void;
    getSide(a: Point, b: Point, c: Point): number;
    handleRelease(newCropTouch: CropperTouch): void;
    handleMove(newCropTouch: CropperTouch): void;
    updateClampBounds(): void;
    getCropBounds(): Bounds;
    clampPosition(x: number, y: number): Point;
    isImageSet(): boolean;
    setImage(img: any): void;
    updateCropPosition(cropBounds: Bounds): void;
    private setCropPosition;
    private getCropPositionFromMarkers;
    private getCropPositionFromBounds;
    getCroppedImageHelper(preserveSize?: boolean, fillWidth?: number, fillHeight?: number): HTMLImageElement;
    getCroppedImage(preserveSize?: boolean, fillWidth?: number, fillHeight?: number): HTMLImageElement;
    getBounds(): Bounds;
    setBounds(bounds: any): void;
    onTouchMove(event: TouchEvent): void;
    onMouseMove(e: MouseEvent): void;
    move(cropTouch: CropperTouch): void;
    getDragTouchForID(id: any): CropperTouch | undefined;
    drawCursors(cropTouch: CropperTouch): void;
    drawCornerCursor(marker: any, x: number, y: number): boolean;
    onTouchStart(event: TouchEvent): void;
    onTouchEnd(event: TouchEvent): void;
    drawImageIOSFix(ctx: CanvasRenderingContext2D, img: HTMLImageElement | HTMLCanvasElement | HTMLVideoElement, sx: number, sy: number, sw: number, sh: number, dx: number, dy: number, dw: number, dh: number): void;
    onMouseDown(event: MouseEvent): void;
    onMouseUp(event: MouseEvent): void;
}
