import { Point } from './point';
import { ImageCropperSettings } from '../image-cropper.settings';
export interface IHandle {
    over: boolean;
    drag: boolean;
    position: Point;
    setPosition(x: number, y: number): void;
    offset: Point;
    radius: number;
    cropperSettings: ImageCropperSettings;
    setDrag(value: boolean): void;
    draw(ctx: CanvasRenderingContext2D): void;
    setOver(over: boolean): void;
    touchInBounds(x: number, y: number): boolean;
}
export declare class Handle implements IHandle {
    _position: Point;
    over: boolean;
    drag: boolean;
    offset: Point;
    radius: number;
    cropperSettings: ImageCropperSettings;
    constructor(x: number, y: number, radius: number, settings: ImageCropperSettings);
    setDrag(value: boolean): void;
    draw(ctx: CanvasRenderingContext2D): void;
    setOver(over: boolean): void;
    touchInBounds(x: number, y: number): boolean;
    readonly position: Point;
    setPosition(x: number, y: number): void;
}
