var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, ChangeDetectionStrategy, Optional, ChangeDetectorRef, Renderer2, Input } from '@angular/core';
import { FileUpload } from '../file-upload/file-upload';
import { HiNGConfig } from '../hi.config';
import { HttpClient } from '@angular/common/http';
import { ModalService } from '../modal';
import { noop } from '../utils';
import { ViewImageModalComponent } from './view-image-modal.component';
var ImageUploadComponent = (function (_super) {
    __extends(ImageUploadComponent, _super);
    function ImageUploadComponent(hiNGConfig, renderer, http, changeDetectorRef, modalService) {
        var _this = _super.call(this, hiNGConfig, renderer, http, changeDetectorRef) || this;
        _this.modalService = modalService;
        _this.viewIcon = _this.hiNGConfig.imageUpload.viewIcon;
        _this.imgPreview = true;
        _this.autoUpload = true;
        _this.accept = 'image/*';
        return _this;
    }
    ImageUploadComponent.prototype.viewImage = function (fileItem) {
        this.modalService.open({
            component: ViewImageModalComponent,
            resolve: { url: fileItem.dataUrl, name: fileItem.name }
        }).subscribe(noop, noop);
    };
    ImageUploadComponent.prototype.uploadBtnIcon = function () {
        return this.isUploading ? this.loadingIcon : this.plusIcon;
    };
    ImageUploadComponent.prototype.onFileUploadError = function (fileItem, error) {
        this.selectFiles = this.selectFiles.filter(function (item) { return item !== fileItem; });
        return _super.prototype.onFileUploadError.call(this, fileItem, error);
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ImageUploadComponent.prototype, "viewIcon", void 0);
    ImageUploadComponent = __decorate([
        Component({
            selector: 'hi-image-upload',
            template: "\n    <input #file type=\"file\" (change)=\"newFileChoose(file)\" style=\"display: none\"><div class=\"image-upload clearfix {{cssClass}}\" reDroppable (onDrop)=\"onDropFiles($event)\"><div *ngFor=\"let fileItem of uploadFiles\" class=\"image-upload-item\" [style.width]=\"previewWidth\" [style.height]=\"previewHeight\"><div class=\"image-upload-image-view\"><div class=\"image-upload-toolbar\"><i class=\"image-upload-toolbar-item image-upload-toolbar-view {{viewIcon}}\" (click)=\"viewImage(fileItem)\"></i> <i class=\"image-upload-toolbar-item image-upload-toolbar-remove {{removeIcon}}\" (click)=\"onRemoveUploadFile(fileItem)\"></i></div><div class=\"image-upload-item-info\"><img class=\"preview-image img-responsive\" [src]=\"fileItem.dataUrl\" [attr.alt]=\"fileItem.file?.name\"></div></div></div><div class=\"image-upload-item image-upload-btn\" [style.width]=\"previewWidth\" [style.height]=\"previewHeight\" (click)=\"addNewFile($event)\" *ngIf=\"!isMoreThanMaxItems() || isUploading\"><div class=\"image-upload-item-info\"><i class=\"image-upload-btn-icon {{uploadBtnIcon()}}\" [ngClass]=\"{'uploading': isUploading}\"></i><div class=\"image-upload-btn-text\">{{uploadButton}}</div></div></div></div><hi-alert-box class=\"file-upload-error-box\" type=\"danger\" [closable]=\"true\" (close)=\"clearErrors()\" *ngIf=\"showErrors && errors.length\"><ul><li *ngFor=\"let error of errors\">{{error}}</li></ul></hi-alert-box>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            exportAs: 'imageUpload'
        }),
        __param(2, Optional()),
        __metadata("design:paramtypes", [HiNGConfig,
            Renderer2,
            HttpClient,
            ChangeDetectorRef,
            ModalService])
    ], ImageUploadComponent);
    return ImageUploadComponent;
}(FileUpload));
export { ImageUploadComponent };
