var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input, Output, EventEmitter, HostListener, ElementRef, TemplateRef } from '@angular/core';
import { WindowRef } from '../window-ref/window-ref.service';
var InfiniteScrollComponent = (function () {
    function InfiniteScrollComponent(windowRef, elementRef) {
        this.windowRef = windowRef;
        this.elementRef = elementRef;
        this.bufferPx = 40;
        this.scrollDelay = 300;
        this.loadMore = new EventEmitter();
        this.scrollStream = new EventEmitter();
    }
    InfiniteScrollComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.setupScrollEvent();
        setTimeout(function (_) { return _this.onWinScroll(null); });
    };
    InfiniteScrollComponent.prototype.loadFinish = function (complete) {
        var _this = this;
        if (complete) {
            return this.unSubscription();
        }
        setTimeout(function (_) { return _this.onWinScroll(null); }, this.scrollDelay);
    };
    InfiniteScrollComponent.prototype.setupScrollEvent = function () {
        var _this = this;
        if (!this.subscription) {
            this.subscription = this.registerOnScrollStream(this.scrollStream)
                .subscribe(function (_) { return _this.onScrollChange(); });
        }
    };
    InfiniteScrollComponent.prototype.onScrollChange = function () {
        var winHeight = this.windowRef.innerHeight;
        var clientRect = this.windowRef.getBoundingClientRect(this.elementRef);
        if (clientRect && winHeight - clientRect.top >= this.bufferPx) {
            this.loadMore.emit(this);
        }
    };
    InfiniteScrollComponent.prototype.onWinScroll = function ($event) {
        this.scrollStream.emit($event);
    };
    InfiniteScrollComponent.prototype.ngOnDestroy = function () {
        this.unSubscription();
    };
    InfiniteScrollComponent.prototype.unSubscription = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
            this.subscription = null;
        }
    };
    InfiniteScrollComponent.prototype.registerOnScrollStream = function (scrollStream) {
        return scrollStream
            .debounceTime(this.scrollDelay)
            .distinctUntilChanged();
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], InfiniteScrollComponent.prototype, "total", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], InfiniteScrollComponent.prototype, "bufferPx", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], InfiniteScrollComponent.prototype, "scrollDelay", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], InfiniteScrollComponent.prototype, "spinnerTemplate", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], InfiniteScrollComponent.prototype, "loadMore", void 0);
    __decorate([
        HostListener('window:scroll', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Event]),
        __metadata("design:returntype", void 0)
    ], InfiniteScrollComponent.prototype, "onWinScroll", null);
    InfiniteScrollComponent = __decorate([
        Component({
            selector: 'hi-infinite-scroll',
            template: "\n    <ng-template #defaultTemplate let-spinner=\"\"><div class=\"spinner\"><div class=\"bounce bounce1\"></div><div class=\"bounce bounce2\"></div><div class=\"bounce bounce3\"></div></div></ng-template><ng-template [ngTemplateOutlet]=\"spinnerTemplate || defaultTemplate\" [ngTemplateOutletContext]=\"{ $implicit: this }\"></ng-template>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            exportAs: 'infiniteScroll'
        }),
        __metadata("design:paramtypes", [WindowRef, ElementRef])
    ], InfiniteScrollComponent);
    return InfiniteScrollComponent;
}());
export { InfiniteScrollComponent };
