import { AfterContentInit, AfterViewInit, ElementRef, QueryList, TemplateRef } from '@angular/core';
import { InputDirective } from './input.directive';
export declare type InputGroupIconClass = string | string[] | Set<string> | {
    [klass: string]: any;
};
export declare type InputGroupSizeType = 'large' | 'default' | 'small';
export declare class InputGroupComponent implements AfterViewInit, AfterContentInit {
    private el;
    private _addOnBefore;
    private _addOnAfter;
    private _prefix;
    private _suffix;
    private _size;
    private _compact;
    private _search;
    private isAddOnBeforeString;
    private isAddOnAfterString;
    private isPrefixString;
    private isSuffixString;
    InputDirectiveQueryList: QueryList<InputDirective>;
    hiAddOnBeforeIcon: InputGroupIconClass;
    hiAddOnAfterIcon: InputGroupIconClass;
    hiPrefixIcon: InputGroupIconClass;
    hiSuffixIcon: InputGroupIconClass;
    hiSize: InputGroupSizeType;
    hiCompact: boolean;
    hiAddOnBefore: string | TemplateRef<void>;
    hiAddOnAfter: string | TemplateRef<void>;
    hiPrefix: string | TemplateRef<void>;
    hiSuffix: string | TemplateRef<void>;
    hiSearch: boolean;
    readonly isLarge: boolean;
    readonly isSmall: boolean;
    readonly isAffix: boolean;
    readonly isAddOn: boolean;
    readonly isGroup: boolean;
    readonly isLargeGroup: boolean;
    readonly isLargeGroupWrapper: boolean;
    readonly isLargeAffix: boolean;
    readonly isLargeSearch: boolean;
    readonly isSmallGroup: boolean;
    readonly isSmallAffix: boolean;
    readonly isSmallGroupWrapper: boolean;
    readonly isSmallSearch: boolean;
    updateChildrenInputSize(): void;
    constructor(el: ElementRef);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
}
