var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ContentChildren, ElementRef, HostBinding, Input, QueryList, TemplateRef } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { trimWhiteSpace } from '../utils/trim-whitespace';
import { InputDirective } from './input.directive';
var InputGroupComponent = (function () {
    function InputGroupComponent(el) {
        this.el = el;
        this._addOnBefore = '';
        this._addOnAfter = '';
        this._prefix = '';
        this._suffix = '';
        this._size = 'default';
        this._compact = false;
        this._search = false;
    }
    Object.defineProperty(InputGroupComponent.prototype, "hiSize", {
        get: function () {
            return this._size;
        },
        set: function (value) {
            this._size = value;
            this.updateChildrenInputSize();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "hiCompact", {
        get: function () {
            return this._compact;
        },
        set: function (value) {
            this._compact = coerceBooleanProperty(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "hiAddOnBefore", {
        get: function () {
            return this._addOnBefore;
        },
        set: function (value) {
            this.isAddOnBeforeString = !(value instanceof TemplateRef);
            this._addOnBefore = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "hiAddOnAfter", {
        get: function () {
            return this._addOnAfter;
        },
        set: function (value) {
            this.isAddOnAfterString = !(value instanceof TemplateRef);
            this._addOnAfter = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "hiPrefix", {
        get: function () {
            return this._prefix;
        },
        set: function (value) {
            this.isPrefixString = !(value instanceof TemplateRef);
            this._prefix = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "hiSuffix", {
        get: function () {
            return this._suffix;
        },
        set: function (value) {
            this.isSuffixString = !(value instanceof TemplateRef);
            this._suffix = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "hiSearch", {
        get: function () {
            return this._search;
        },
        set: function (value) {
            this._search = coerceBooleanProperty(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isLarge", {
        get: function () {
            return this.hiSize === 'large';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isSmall", {
        get: function () {
            return this.hiSize === 'small';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isAffix", {
        get: function () {
            return !!(this.hiSuffix || this.hiPrefix || this.hiPrefixIcon || this.hiSuffixIcon);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isAddOn", {
        get: function () {
            return !!(this.hiAddOnAfter || this.hiAddOnBefore || this.hiAddOnAfterIcon || this.hiAddOnBeforeIcon);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isGroup", {
        get: function () {
            return (!this.isAffix) && (!this.isAddOn);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isLargeGroup", {
        get: function () {
            return this.isGroup && this.isLarge;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isLargeGroupWrapper", {
        get: function () {
            return this.isAddOn && this.isLarge;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isLargeAffix", {
        get: function () {
            return this.isAffix && this.isLarge;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isLargeSearch", {
        get: function () {
            return this.hiSearch && this.isLarge;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isSmallGroup", {
        get: function () {
            return this.isGroup && this.isSmall;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isSmallAffix", {
        get: function () {
            return this.isAffix && this.isSmall;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isSmallGroupWrapper", {
        get: function () {
            return this.isAddOn && this.isSmall;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupComponent.prototype, "isSmallSearch", {
        get: function () {
            return this.hiSearch && this.isSmall;
        },
        enumerable: true,
        configurable: true
    });
    InputGroupComponent.prototype.updateChildrenInputSize = function () {
        var _this = this;
        if (this.InputDirectiveQueryList) {
            this.InputDirectiveQueryList.forEach(function (item) { return item.hiSize = _this.hiSize; });
        }
    };
    InputGroupComponent.prototype.ngAfterContentInit = function () {
        this.updateChildrenInputSize();
    };
    InputGroupComponent.prototype.ngAfterViewInit = function () {
        trimWhiteSpace(this.el.nativeElement);
    };
    __decorate([
        ContentChildren(InputDirective),
        __metadata("design:type", QueryList)
    ], InputGroupComponent.prototype, "InputDirectiveQueryList", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], InputGroupComponent.prototype, "hiAddOnBeforeIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], InputGroupComponent.prototype, "hiAddOnAfterIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], InputGroupComponent.prototype, "hiPrefixIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], InputGroupComponent.prototype, "hiSuffixIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], InputGroupComponent.prototype, "hiSize", null);
    __decorate([
        Input(),
        HostBinding("class.hi-input-group-compact"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], InputGroupComponent.prototype, "hiCompact", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], InputGroupComponent.prototype, "hiAddOnBefore", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], InputGroupComponent.prototype, "hiAddOnAfter", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], InputGroupComponent.prototype, "hiPrefix", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], InputGroupComponent.prototype, "hiSuffix", null);
    __decorate([
        Input(),
        HostBinding("class.hi-input-search-enter-button"),
        HostBinding("class.hi-input-search"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], InputGroupComponent.prototype, "hiSearch", null);
    __decorate([
        HostBinding('class.hi-input-affix-wrapper'),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isAffix", null);
    __decorate([
        HostBinding('class.hi-input-group-wrapper'),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isAddOn", null);
    __decorate([
        HostBinding('class.hi-input-group'),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isGroup", null);
    __decorate([
        HostBinding("class.hi-input-group-lg"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isLargeGroup", null);
    __decorate([
        HostBinding("class.hi-input-group-wrapper-lg"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isLargeGroupWrapper", null);
    __decorate([
        HostBinding("class.hi-input-affix-wrapper-lg"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isLargeAffix", null);
    __decorate([
        HostBinding("class.hi-input-search-lg"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isLargeSearch", null);
    __decorate([
        HostBinding("class.hi-input-group-sm"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isSmallGroup", null);
    __decorate([
        HostBinding("class.hi-input-affix-wrapper-sm"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isSmallAffix", null);
    __decorate([
        HostBinding("class.hi-input-group-wrapper-sm"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isSmallGroupWrapper", null);
    __decorate([
        HostBinding("class.hi-input-search-sm"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputGroupComponent.prototype, "isSmallSearch", null);
    InputGroupComponent = __decorate([
        Component({
            selector: 'hi-input-group',
            preserveWhitespaces: false,
            template: "\n    <span class=\"hi-input-wrapper hi-input-group\" *ngIf=\"isAddOn\">\n      <span class=\"hi-input-group-addon\" *ngIf=\"hiAddOnBefore || hiAddOnBeforeIcon\">\n        <i [ngClass]=\"hiAddOnBeforeIcon\" *ngIf=\"hiAddOnBeforeIcon\"></i>\n        <ng-container *ngIf=\"isAddOnBeforeString; else addOnBeforeTemplate\">{{ hiAddOnBefore }}</ng-container>\n        <ng-template #addOnBeforeTemplate>\n          <ng-template [ngTemplateOutlet]=\"hiAddOnBefore\"></ng-template>\n        </ng-template>\n      </span>\n      <ng-template *ngTemplateOutlet=\"contentTemplate\"></ng-template>\n      <span class=\"hi-input-group-addon\" *ngIf=\"hiAddOnAfter || hiAddOnAfterIcon\">\n        <i [ngClass]=\"hiAddOnAfterIcon\" *ngIf=\"hiAddOnAfterIcon\"></i>\n        <ng-container *ngIf=\"isAddOnAfterString; else addOnAfterTemplate\">{{ hiAddOnAfter }}</ng-container>\n        <ng-template #addOnAfterTemplate>\n          <ng-template [ngTemplateOutlet]=\"hiAddOnAfter\"></ng-template>\n        </ng-template>\n      </span>\n    </span>\n    <ng-template [ngIf]=\"isAffix\">\n      <span class=\"hi-input-prefix\" *ngIf=\"hiPrefix || hiPrefixIcon\">\n        <i [ngClass]=\"hiPrefixIcon\" *ngIf=\"hiPrefixIcon\"></i>\n        <ng-container *ngIf=\"isPrefixString; else prefixTemplate\">{{ hiPrefix }}</ng-container>\n        <ng-template #prefixTemplate>\n          <ng-template [ngTemplateOutlet]=\"hiPrefix\"></ng-template>\n        </ng-template>\n      </span>\n      <ng-template *ngTemplateOutlet=\"contentTemplate\"></ng-template>\n      <span class=\"hi-input-suffix\" *ngIf=\"hiSuffix || hiSuffixIcon\">\n        <i [ngClass]=\"hiSuffixIcon\" *ngIf=\"hiSuffixIcon\"></i>\n        <ng-container *ngIf=\"isSuffixString; else suffixTemplate\">{{ hiSuffix }}</ng-container>\n        <ng-template #suffixTemplate>\n          <ng-template [ngTemplateOutlet]=\"hiSuffix\"></ng-template>\n        </ng-template>\n      </span>\n    </ng-template>\n    <ng-template [ngIf]=\"isGroup\" *ngTemplateOutlet=\"contentTemplate\"></ng-template>\n    <ng-template #contentTemplate>\n      <ng-content></ng-content>\n    </ng-template>\n  ",
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], InputGroupComponent);
    return InputGroupComponent;
}());
export { InputGroupComponent };
