var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Directive, ElementRef, HostBinding, HostListener, Input, Optional, Renderer2, Self } from '@angular/core';
import { NgControl, NgModel } from '@angular/forms';
import calculateNodeHeight from '../utils/calculate-node-height';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
var InputDirective = (function () {
    function InputDirective(elementRef, renderer, ngModel, ngControl) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.ngModel = ngModel;
        this.ngControl = ngControl;
        this._size = 'default';
        this._disabled = false;
        this._autosize = false;
        this.isInit = false;
        this.el = this.elementRef.nativeElement;
    }
    Object.defineProperty(InputDirective.prototype, "hiSize", {
        get: function () {
            return this._size;
        },
        set: function (value) {
            this._size = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputDirective.prototype, "disabled", {
        get: function () {
            if (this.ngControl && this.ngControl.disabled !== null) {
                return this.ngControl.disabled;
            }
            return this._disabled;
        },
        set: function (value) {
            this._disabled = coerceBooleanProperty(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputDirective.prototype, "hiAutosize", {
        get: function () {
            return this._autosize;
        },
        set: function (value) {
            if (typeof value === 'string') {
                this._autosize = true;
            }
            else {
                this._autosize = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputDirective.prototype, "setLgClass", {
        get: function () {
            return this.hiSize === 'large';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputDirective.prototype, "setSmClass", {
        get: function () {
            return this.hiSize === 'small';
        },
        enumerable: true,
        configurable: true
    });
    InputDirective.prototype.textAreaOnChange = function () {
        if (this.hiAutosize) {
            this.resizeTextArea();
        }
    };
    InputDirective.prototype.resizeTextArea = function () {
        var textAreaRef = this.el;
        var maxRows = this.hiAutosize ? this.hiAutosize.maxRows || null : null;
        var minRows = this.hiAutosize ? this.hiAutosize.minRows || null : null;
        if ((this.previousValue === textAreaRef.value) && (this.previewsMaxRows === maxRows) && (this.previewsMinRows === minRows)) {
            return;
        }
        this.previousValue = textAreaRef.value;
        this.previewsMinRows = minRows;
        this.previewsMaxRows = maxRows;
        this.renderer.setStyle(textAreaRef, 'height', 'auto');
        var textAreaStyles = calculateNodeHeight(textAreaRef, false, minRows, maxRows);
        this.renderer.setStyle(textAreaRef, 'height', textAreaStyles.height + "px");
        this.renderer.setStyle(textAreaRef, 'overflowY', textAreaStyles.overflowY);
        this.renderer.setStyle(textAreaRef, 'minHeight', textAreaStyles.minHeight + "px");
        this.renderer.setStyle(textAreaRef, 'maxHeight', textAreaStyles.maxHeight + "px");
    };
    InputDirective.prototype.ngDoCheck = function () {
        if (this.hiAutosize && this.isInit) {
            this.resizeTextArea();
        }
    };
    InputDirective.prototype.ngAfterViewInit = function () {
        this.isInit = true;
        if (this.hiAutosize) {
            this.resizeTextArea();
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], InputDirective.prototype, "hiSize", null);
    __decorate([
        Input(),
        HostBinding("class.hi-input-disabled"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], InputDirective.prototype, "disabled", null);
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], InputDirective.prototype, "hiAutosize", null);
    __decorate([
        HostBinding("class.hi-input-lg"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputDirective.prototype, "setLgClass", null);
    __decorate([
        HostBinding("class.hi-input-sm"),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], InputDirective.prototype, "setSmClass", null);
    __decorate([
        HostListener('input'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], InputDirective.prototype, "textAreaOnChange", null);
    InputDirective = __decorate([
        Directive({
            selector: '[hi-input]',
            host: {
                '[class.hi-input]': 'true'
            }
        }),
        __param(2, Optional()),
        __param(3, Optional()), __param(3, Self()),
        __metadata("design:paramtypes", [ElementRef,
            Renderer2,
            NgModel,
            NgControl])
    ], InputDirective);
    return InputDirective;
}());
export { InputDirective };
