var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, Inject, Optional } from '@angular/core';
import { MESSAGE_CONFIG, MESSAGE_DEFAULT_CONFIG } from './message-config';
var MessageContainerComponent = (function () {
    function MessageContainerComponent(defaultConfig, config) {
        this.messages = [];
        this.config = {};
        this.setConfig(__assign({}, defaultConfig, config));
    }
    MessageContainerComponent.prototype.setConfig = function (config) {
        this.config = __assign({}, this.config, config);
    };
    MessageContainerComponent.prototype.createMessage = function (message) {
        if (this.messages.length >= this.config.hiMaxStack) {
            this.messages.splice(0, 1);
        }
        message.options = this._mergeMessageOptions(message.options);
        this.messages.push(message);
    };
    MessageContainerComponent.prototype.removeMessage = function (messageId) {
        var _this = this;
        this.messages.some(function (message, index) {
            if (message.messageId === messageId) {
                _this.messages.splice(index, 1);
                return true;
            }
        });
    };
    MessageContainerComponent.prototype.removeMessageAll = function () {
        this.messages = [];
    };
    MessageContainerComponent.prototype._mergeMessageOptions = function (options) {
        var defaultOptions = {
            hiDuration: this.config.hiDuration,
            hiAnimate: this.config.hiAnimate,
            hiPauseOnHover: this.config.hiPauseOnHover
        };
        return __assign({}, defaultOptions, options);
    };
    MessageContainerComponent = __decorate([
        Component({
            selector: 'hi-message-container',
            preserveWhitespaces: false,
            template: "\n    <div class=\"hi-message\"><hi-message *ngFor=\"let message of messages; let i = index\" [hiMessage]=\"message\" [hiIndex]=\"i\"></hi-message></div>\n  "
        }),
        __param(0, Optional()), __param(0, Inject(MESSAGE_DEFAULT_CONFIG)),
        __param(1, Optional()), __param(1, Inject(MESSAGE_CONFIG)),
        __metadata("design:paramtypes", [Object, Object])
    ], MessageContainerComponent);
    return MessageContainerComponent;
}());
export { MessageContainerComponent };
