import { Overlay } from '@angular/cdk/overlay';
import { ApplicationRef, ComponentFactoryResolver, Injector, Type } from '@angular/core';
import { MessageConfig } from './message-config';
import { MessageContainerComponent } from './message-container.component';
import { MessageData, MessageDataFilled, MessageDataOptions } from './message.definitions';
export declare class MessageBaseService<ContainerClass extends MessageContainerComponent, MessageData, MessageConfig1 extends MessageConfig> {
    private overlay;
    private containerClass;
    private injector;
    private cfr;
    private appRef;
    private _idPrefix;
    protected _container: ContainerClass;
    constructor(overlay: Overlay, containerClass: Type<ContainerClass>, injector: Injector, cfr: ComponentFactoryResolver, appRef: ApplicationRef, _idPrefix?: string);
    remove(messageId?: string): void;
    createMessage(message: MessageData, options?: MessageDataOptions): MessageDataFilled;
    config(config: MessageConfig1): void;
    protected _generateMessageId(): string;
    private createContainer;
}
export declare class MessageService extends MessageBaseService<MessageContainerComponent, MessageData, MessageConfig> {
    constructor(overlay: Overlay, injector: Injector, cfr: ComponentFactoryResolver, appRef: ApplicationRef);
    success(content: string, options?: MessageDataOptions): MessageDataFilled;
    error(content: string, options?: MessageDataOptions): MessageDataFilled;
    info(content: string, options?: MessageDataOptions): MessageDataFilled;
    warning(content: string, options?: MessageDataOptions): MessageDataFilled;
    loading(content: string, options?: MessageDataOptions): MessageDataFilled;
    create(type: 'success' | 'info' | 'warning' | 'error' | 'loading' | string, content: string, options?: MessageDataOptions): MessageDataFilled;
}
