var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ViewChild, HostListener, EventEmitter, ElementRef, Output } from '@angular/core';
import { ModalContentComponent } from './modal-content.component';
import { ModalDismissReasons } from './modal-dismiss-reasons.model';
import { trigger, state, style, transition, animate } from '@angular/animations';
var ModalWindowComponent = (function () {
    function ModalWindowComponent(elementRef) {
        this.elementRef = elementRef;
        this.isOpen = false;
        this.instanceCount = 0;
        this.animationDone = new EventEmitter();
    }
    ModalWindowComponent.prototype.open = function () {
        this.isOpen = true;
        if (this.modalOptions.animation) {
            this.animateState = 'in';
        }
    };
    ModalWindowComponent.prototype.close = function () {
        var _this = this;
        this.isOpen = false;
        if (this.modalOptions.animation) {
            this.animateState = 'void';
            return this.animationDone;
        }
        setTimeout(function () { return _this.onAnimationDone(null); });
        return this.animationDone;
    };
    ModalWindowComponent.prototype.onAnimationDone = function ($event) {
        this.animationDone.emit($event);
    };
    ModalWindowComponent.prototype.onBackdropClick = function ($event) {
        if (!this.modalOptions.modal && this.elementRef.nativeElement === $event.target) {
            this.dismiss.error(ModalDismissReasons.BACKDROP_CLICK);
        }
    };
    ModalWindowComponent.prototype.onEscKeyUp = function ($event) {
        if (this.modalOptions.keyboard !== false) {
            this.dismiss.error(ModalDismissReasons.ESC_KEY);
        }
    };
    ModalWindowComponent.prototype.addContent = function (options, dismiss) {
        this.modalOptions = options;
        this.dismiss = dismiss;
        this.modalContent.addContent(options, this.dismiss);
        return this.dismiss;
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ModalWindowComponent.prototype, "isOpen", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ModalWindowComponent.prototype, "instanceCount", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ModalWindowComponent.prototype, "animationDone", void 0);
    __decorate([
        ViewChild(ModalContentComponent, { static: false }),
        __metadata("design:type", ModalContentComponent)
    ], ModalWindowComponent.prototype, "modalContent", void 0);
    __decorate([
        HostListener('click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Event]),
        __metadata("design:returntype", void 0)
    ], ModalWindowComponent.prototype, "onBackdropClick", null);
    __decorate([
        HostListener('keyup.esc', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [KeyboardEvent]),
        __metadata("design:returntype", void 0)
    ], ModalWindowComponent.prototype, "onEscKeyUp", null);
    ModalWindowComponent = __decorate([
        Component({
            selector: 'hi-modal-window',
            template: "\n    <div class=\"modal-dialog {{(modalOptions.size ? ' modal-' + modalOptions.size : '')}}\" role=\"document\"><div class=\"modal-content\"><hi-modal-content #modalContent></hi-modal-content></div></div>\n  ",
            host: {
                '[@flyInOut]': 'animateState',
                '(@flyInOut.done)': 'onAnimationDone($event)'
            },
            animations: [
                trigger('flyInOut', [
                    state('void', style({ top: '-100%', opacity: 0 })),
                    state('in', style({ top: '10%', opacity: 1 })),
                    transition('void => in', animate('0.2s ease-in-out')),
                    transition('in => void', animate('0.2s ease-in-out')),
                ])
            ]
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], ModalWindowComponent);
    return ModalWindowComponent;
}());
export { ModalWindowComponent };
