var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ViewChild, EventEmitter, Output, Renderer2 } from '@angular/core';
import { ModalWindowComponent } from './modal-window.component';
import { DocumentRef } from '../window-ref';
import 'rxjs/add/operator/do';
var ModalComponent = (function () {
    function ModalComponent(renderer, documentRef) {
        this.renderer = renderer;
        this.documentRef = documentRef;
        this.isOpen = false;
        this.dismiss = new EventEmitter();
        this.instanceCount = 0;
    }
    ModalComponent_1 = ModalComponent;
    ModalComponent.prototype.open = function () {
        this.isOpen = true;
        this.modalWindowComponent.open();
        this.toggleBodyClass(true);
    };
    ModalComponent.prototype.close = function () {
        var _this = this;
        return this.modalWindowComponent.close()
            .do(function (_) { return _this.isOpen = false; });
    };
    ModalComponent.prototype.cleanup = function () {
        this.toggleBodyClass(false);
    };
    ModalComponent.prototype.addContent = function (options, instanceCount) {
        this.modalOptions = options;
        this.instanceCount = instanceCount;
        this.modalWindowComponent.addContent(options, this.dismiss);
        return this.dismiss;
    };
    ModalComponent.prototype.toggleBodyClass = function (isAdd) {
        if (isAdd) {
            this.renderer.addClass(this.documentRef.body, ModalComponent_1.MODEL_OPEN_CSS);
            return;
        }
        this.renderer.removeClass(this.documentRef.body, ModalComponent_1.MODEL_OPEN_CSS);
    };
    var ModalComponent_1;
    ModalComponent.MODEL_OPEN_CSS = 'modal-open';
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ModalComponent.prototype, "isOpen", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ModalComponent.prototype, "dismiss", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ModalComponent.prototype, "modalOptions", void 0);
    __decorate([
        ViewChild(ModalWindowComponent, { static: false }),
        __metadata("design:type", ModalWindowComponent)
    ], ModalComponent.prototype, "modalWindowComponent", void 0);
    ModalComponent = ModalComponent_1 = __decorate([
        Component({
            selector: 'hi-modal',
            template: "\n    <hi-modal-window [instanceCount]=\"instanceCount\" [isOpen]=\"isOpen\" role=\"dialog\" class=\"modal fade {{modalOptions.modalClass? modalOptions.modalClass : ''}}\" [ngClass]=\"{'in': isOpen}\" [ngStyle]=\"{'display': isOpen ? 'block': 'none','z-index': 1050 + instanceCount *10}\" tabindex=\"-1\"></hi-modal-window><hi-modal-backdrop [instanceCount]=\"instanceCount\" [modalOptions]=\"modalOptions\" [isOpen]=\"isOpen\" *ngIf=\"modalOptions.backdrop !== false\"></hi-modal-backdrop>\n  "
        }),
        __metadata("design:paramtypes", [Renderer2, DocumentRef])
    ], ModalComponent);
    return ModalComponent;
}());
export { ModalComponent };
