var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { animate, state, style, transition, trigger } from '@angular/animations';
import { Component, Input, ViewEncapsulation } from '@angular/core';
import { MessageComponent } from '../message/message.component';
import { NotificationContainerComponent } from './notification-container.component';
var NotificationComponent = (function (_super) {
    __extends(NotificationComponent, _super);
    function NotificationComponent(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        return _this;
    }
    NotificationComponent.prototype.close = function () {
        this._destroy();
    };
    Object.defineProperty(NotificationComponent.prototype, "state", {
        get: function () {
            if (this.hiMessage.state === 'enter') {
                if ((this.container.config.hiPlacement === 'topLeft') || (this.container.config.hiPlacement === 'bottomLeft')) {
                    return 'enterLeft';
                }
                else {
                    return 'enterRight';
                }
            }
            else {
                return this.hiMessage.state;
            }
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], NotificationComponent.prototype, "hiMessage", void 0);
    NotificationComponent = __decorate([
        Component({
            selector: 'hi-notification',
            preserveWhitespaces: false,
            animations: [
                trigger('enterLeave', [
                    state('enterRight', style({ opacity: 1, transform: 'translateX(0)' })),
                    transition('* => enterRight', [
                        style({ opacity: 0, transform: 'translateX(5%)' }),
                        animate('100ms linear')
                    ]),
                    state('enterLeft', style({ opacity: 1, transform: 'translateX(0)' })),
                    transition('* => enterLeft', [
                        style({ opacity: 0, transform: 'translateX(-5%)' }),
                        animate('100ms linear')
                    ]),
                    state('leave', style({
                        opacity: 0,
                        transform: 'scaleY(0.8)',
                        transformOrigin: '0% 0%'
                    })),
                    transition('* => leave', [
                        style({
                            opacity: 1,
                            transform: 'scaleY(1)',
                            transformOrigin: '0% 0%'
                        }),
                        animate('100ms linear')
                    ])
                ])
            ],
            template: "\n    <div class=\"hi-notification-notice hi-notification-notice-closable\" [ngStyle]=\"hiMessage.options.hiStyle\" [ngClass]=\"hiMessage.options.hiClass\" [@enterLeave]=\"state\" (mouseenter)=\"onEnter()\" (mouseleave)=\"onLeave()\"><div *ngIf=\"!hiMessage.template\" class=\"hi-notification-notice-content\"><div class=\"hi-notification-notice-content\" [ngClass]=\"{ 'hi-notification-notice-with-icon': hiMessage.type !== 'blank' }\"><div [class.hi-notification-notice-with-icon]=\"hiMessage.type !== 'blank'\"><ng-container [ngSwitch]=\"hiMessage.type\"><i *ngSwitchCase=\"'success'\" class=\"hi-notification-notice-icon hi-notification-notice-icon-success anticon anticon-check-circle-o\"></i> <i *ngSwitchCase=\"'info'\" class=\"hi-notification-notice-icon hi-notification-notice-icon-info anticon anticon-info-circle-o\"></i> <i *ngSwitchCase=\"'warning'\" class=\"hi-notification-notice-icon hi-notification-notice-icon-warning anticon anticon-exclamation-circle-o\"></i> <i *ngSwitchCase=\"'error'\" class=\"hi-notification-notice-icon hi-notification-notice-icon-error anticon anticon-cross-circle-o\"></i></ng-container><div class=\"hi-notification-notice-message\" [innerHTML]=\"hiMessage.title\"></div><div class=\"hi-notification-notice-description\" [innerHTML]=\"hiMessage.content\"></div></div></div></div><ng-template [ngIf]=\"hiMessage.template\" [ngTemplateOutlet]=\"hiMessage.template\" [ngTemplateOutletContext]=\"{ $implicit: this }\"></ng-template><a tabindex=\"0\" class=\"hi-notification-notice-close\" (click)=\"close()\"><span class=\"hi-notification-notice-close-x\"></span></a></div>\n  ",
            styles: ["\n    @font-face{font-family:anticon;src:url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.eot);src:url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.eot#iefix) format(\"embedded-opentype\"),url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.woff) format(\"woff\"),url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.ttf) format(\"truetype\"),url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.svg#iconfont) format(\"svg\")}.anticon{display:inline-block;font-style:normal;vertical-align:baseline;text-align:center;text-transform:none;line-height:1;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}.anticon::before{display:block;font-family:anticon!important}.anticon-info-circle:before{content:\"\\e628\"}.anticon-info-circle-o:before{content:\"\\e629\"}.anticon-check-circle:before{content:\"\\e630\"}.anticon-check-circle-o:before{content:\"\\e631\"}.anticon-exclamation-circle:before{content:\"\\e62c\"}.anticon-exclamation-circle-o:before{content:\"\\e62d\"}.anticon-cross-circle:before{content:\"\\e62e\"}.anticon-cross-circle-o:before{content:\"\\e62f\"}.hi-notification{font-family:\"Monospaced Number\",\"Chinese Quote\",-apple-system,BlinkMacSystemFont,\"Segoe UI\",Roboto,\"PingFang SC\",\"Hiragino Sans GB\",\"Microsoft YaHei\",\"Helvetica Neue\",Helvetica,Arial,sans-serif;font-size:14px;line-height:1.5;color:rgba(0,0,0,.65);-webkit-box-sizing:border-box;box-sizing:border-box;margin:0 24px 0 0;padding:0;list-style:none;position:fixed;z-index:1010;width:384px;max-width:calc(100vw - 32px)}.hi-notification-bottomLeft,.hi-notification-topLeft{margin-left:24px;margin-right:0}.hi-notification-bottomLeft .hi-notification-fade-appear.hi-notification-fade-appear-active,.hi-notification-bottomLeft .hi-notification-fade-enter.hi-notification-fade-enter-active,.hi-notification-topLeft .hi-notification-fade-appear.hi-notification-fade-appear-active,.hi-notification-topLeft .hi-notification-fade-enter.hi-notification-fade-enter-active{-webkit-animation-name:NotificationLeftFadeIn;animation-name:NotificationLeftFadeIn}.hi-notification-notice{padding:16px 24px;border-radius:4px;-webkit-box-shadow:0 4px 12px rgba(0,0,0,.15);box-shadow:0 4px 12px rgba(0,0,0,.15);background:#fff;line-height:1.5;position:relative;margin-bottom:16px;overflow:hidden}.hi-notification-notice-message{font-size:16px;color:rgba(0,0,0,.85);margin-bottom:8px;line-height:24px;display:inline-block}.hi-notification-notice-message-single-line-auto-margin{width:calc(384px - 24px * 2 - 24px - 48px - 100%);background-color:transparent;pointer-events:none;display:block;max-width:4px}.hi-notification-notice-message-single-line-auto-margin:before{content:'';display:block;padding-bottom:100%}.hi-notification-notice-description{font-size:14px}.hi-notification-notice-closable .hi-notification-notice-message{padding-right:24px}.hi-notification-notice-with-icon .hi-notification-notice-message{font-size:16px;margin-left:48px;margin-bottom:4px}.hi-notification-notice-with-icon .hi-notification-notice-description{margin-left:48px;font-size:14px}.hi-notification-notice-icon{position:absolute;font-size:24px;line-height:24px;margin-left:4px}.hi-notification-notice-icon-success{color:#52c41a}.hi-notification-notice-icon-info{color:#28a745}.hi-notification-notice-icon-warning{color:#faad14}.hi-notification-notice-icon-error{color:#f5222d}.hi-notification-notice-close-x:after{font-size:14px;content:\"\\e633\";font-family:anticon;cursor:pointer}.hi-notification-notice-close{position:absolute;right:22px;top:16px;color:rgba(0,0,0,.45);outline:0}a.hi-notification-notice-close:focus{text-decoration:none}.hi-notification-notice-close:hover{color:#404040}.hi-notification-notice-btn{float:right;margin-top:16px}.hi-notification .notification-fade-effect{-webkit-animation-duration:.24s;animation-duration:.24s;-webkit-animation-fill-mode:both;animation-fill-mode:both;-webkit-animation-timing-function:cubic-bezier(.645,.045,.355,1);animation-timing-function:cubic-bezier(.645,.045,.355,1)}.hi-notification-fade-appear,.hi-notification-fade-enter{opacity:0;-webkit-animation-duration:.24s;animation-duration:.24s;-webkit-animation-fill-mode:both;animation-fill-mode:both;-webkit-animation-timing-function:cubic-bezier(.645,.045,.355,1);animation-timing-function:cubic-bezier(.645,.045,.355,1);-webkit-animation-play-state:paused;animation-play-state:paused}.hi-notification-fade-leave{-webkit-animation-fill-mode:both;animation-fill-mode:both;-webkit-animation-timing-function:cubic-bezier(.645,.045,.355,1);animation-timing-function:cubic-bezier(.645,.045,.355,1);-webkit-animation-duration:.2s;animation-duration:.2s;-webkit-animation-play-state:paused;animation-play-state:paused}.hi-notification-fade-appear.hi-notification-fade-appear-active,.hi-notification-fade-enter.hi-notification-fade-enter-active{-webkit-animation-name:NotificationFadeIn;animation-name:NotificationFadeIn;-webkit-animation-play-state:running;animation-play-state:running}.hi-notification-fade-leave.hi-notification-fade-leave-active{-webkit-animation-name:NotificationFadeOut;animation-name:NotificationFadeOut;-webkit-animation-play-state:running;animation-play-state:running}@-webkit-keyframes NotificationFadeIn{0%{opacity:0;left:384px}100%{left:0;opacity:1}}@keyframes NotificationFadeIn{0%{opacity:0;left:384px}100%{left:0;opacity:1}}@-webkit-keyframes NotificationLeftFadeIn{0%{opacity:0;right:384px}100%{right:0;opacity:1}}@keyframes NotificationLeftFadeIn{0%{opacity:0;right:384px}100%{right:0;opacity:1}}@-webkit-keyframes NotificationFadeOut{0%{opacity:1;margin-bottom:16px;padding-top:16px 24px;padding-bottom:16px 24px;max-height:150px}100%{opacity:0;margin-bottom:0;padding-top:0;padding-bottom:0;max-height:0}}@keyframes NotificationFadeOut{0%{opacity:1;margin-bottom:16px;padding-top:16px 24px;padding-bottom:16px 24px;max-height:150px}100%{opacity:0;margin-bottom:0;padding-top:0;padding-bottom:0;max-height:0}}\n  "],
            encapsulation: ViewEncapsulation.None,
        }),
        __metadata("design:paramtypes", [NotificationContainerComponent])
    ], NotificationComponent);
    return NotificationComponent;
}(MessageComponent));
export { NotificationComponent };
