import { Overlay } from '@angular/cdk/overlay';
import { ApplicationRef, ComponentFactoryResolver, Injector, TemplateRef } from '@angular/core';
import { MessageBaseService } from '../message/message.service';
import { NotificationConfig } from './notification-config';
import { NotificationContainerComponent } from './notification-container.component';
import { NotificationData, NotificationDataFilled, NotificationDataOptions } from './notification.definitions';
export declare class NotificationService extends MessageBaseService<NotificationContainerComponent, NotificationData, NotificationConfig> {
    constructor(overlay: Overlay, injector: Injector, cfr: ComponentFactoryResolver, appRef: ApplicationRef);
    success(title: string, content: string, options?: NotificationDataOptions): NotificationDataFilled;
    error(title: string, content: string, options?: NotificationDataOptions): NotificationDataFilled;
    info(title: string, content: string, options?: NotificationDataOptions): NotificationDataFilled;
    warning(title: string, content: string, options?: NotificationDataOptions): NotificationDataFilled;
    blank(title: string, content: string, options?: NotificationDataOptions): NotificationDataFilled;
    create(type: 'success' | 'info' | 'warning' | 'error' | 'blank' | string, title: string, content: string, options?: NotificationDataOptions): NotificationDataFilled;
    template(template: TemplateRef<{}>, options?: NotificationDataOptions): NotificationDataFilled;
}
