var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable, ComponentFactoryResolver } from '@angular/core';
import { HiNGConfig } from '../hi.config';
import { NotifyComponent } from './notify.component';
var NotifyService = (function () {
    function NotifyService(hiNGConfig, componentFactoryResolver) {
        this.hiNGConfig = hiNGConfig;
        this.componentFactoryResolver = componentFactoryResolver;
    }
    NotifyService.prototype.placement = function (placement) {
        if (this.panelRef) {
            this.panelRef.instance.placement = placement || 'top-right';
        }
        this._placement = placement;
    };
    NotifyService.prototype.open = function (notify, duration) {
        var _this = this;
        if (!this.panelRef) {
            var rootContainer = this.hiNGConfig.rootContainer;
            var componentFactory = this.componentFactoryResolver.resolveComponentFactory(NotifyComponent);
            this.panelRef = rootContainer.createComponent(componentFactory, rootContainer.length);
            if (this.placement) {
                this.panelRef.instance.placement = this._placement;
            }
        }
        this.panelRef.instance.notifies = this.panelRef.instance.notifies.concat([notify]);
        if (duration) {
            var timeout_1 = setTimeout(function () {
                clearTimeout(timeout_1);
                _this.close(notify);
            }, duration);
        }
    };
    NotifyService.prototype.close = function (alertModel) {
        this.panelRef.instance.notifies = this.panelRef.instance.notifies.filter(function (alert) { return alert !== alertModel; });
        this.panelRef.changeDetectorRef.markForCheck();
    };
    NotifyService.prototype.closeAll = function () {
        this.panelRef.instance.notifies = [];
        this.panelRef.changeDetectorRef.markForCheck();
    };
    NotifyService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HiNGConfig,
            ComponentFactoryResolver])
    ], NotifyService);
    return NotifyService;
}());
export { NotifyService };
