var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { OAuth2Service } from './oauth2.service';
var OAuth2Guard = (function () {
    function OAuth2Guard(router, service) {
        this.router = router;
        this.service = service;
    }
    OAuth2Guard.prototype.canActivate = function (route, state) {
        var isAuthorized = this.service.isAuthorized();
        if (isAuthorized && state.url === '/') {
            this.navigate(this.service.config.homeUri);
        }
        if (!isAuthorized && this.isPublicPage(state)) {
            this.navigate(this.service.config.backUri);
        }
        return isAuthorized;
    };
    OAuth2Guard.prototype.canActivateChild = function (route, state) {
        return this.canActivate(route, state);
    };
    OAuth2Guard.prototype.isPublicPage = function (state) {
        return state.url === this.service.config.backUri ? false : true;
    };
    OAuth2Guard.prototype.navigate = function (url) {
        if (url.startsWith('http')) {
            window.location.href = url;
        }
        else {
            this.router.navigateByUrl(url);
        }
    };
    OAuth2Guard = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [Router,
            OAuth2Service])
    ], OAuth2Guard);
    return OAuth2Guard;
}());
export { OAuth2Guard };
