var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ViewChild, ElementRef, Renderer2, HostListener } from '@angular/core';
import { WindowRef } from '../window-ref/window-ref.service';
import { OverlayContentComponent } from './overlay-content.component';
import { centerWindowPosition } from '../utils/dom-utils';
var OverlayComponent = (function () {
    function OverlayComponent(windowRef, renderer) {
        this.windowRef = windowRef;
        this.renderer = renderer;
    }
    OverlayComponent.prototype.addContent = function (options) {
        this.overlayOptions = options;
        if (!this.overlayOptions.html && this.overlayOptions.component) {
            this.overlayContent.addContent(this.overlayOptions);
        }
        this.adjustOverlayPosition();
    };
    OverlayComponent.prototype.onWinResize = function () {
        this.adjustOverlayPosition();
    };
    OverlayComponent.prototype.adjustOverlayPosition = function () {
        var _this = this;
        setTimeout(function () {
            var pos = centerWindowPosition(_this.overlayBody, _this.windowRef);
            _this.renderer.setStyle(_this.overlayBody.nativeElement, 'top', pos.top + "px");
            _this.renderer.setStyle(_this.overlayBody.nativeElement, 'left', pos.left + "px");
        }, 0);
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], OverlayComponent.prototype, "overlayOptions", void 0);
    __decorate([
        ViewChild('overlayBody', { static: false }),
        __metadata("design:type", ElementRef)
    ], OverlayComponent.prototype, "overlayBody", void 0);
    __decorate([
        ViewChild(OverlayContentComponent, { static: false }),
        __metadata("design:type", OverlayContentComponent)
    ], OverlayComponent.prototype, "overlayContent", void 0);
    __decorate([
        HostListener('window:resize', []),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], OverlayComponent.prototype, "onWinResize", null);
    OverlayComponent = __decorate([
        Component({
            selector: 'hi-overlay',
            template: "\n    <div #overlayBody class=\"overlay-body\" style=\"z-index: 1050;top:300px;left: 200px\"><div *ngIf=\"overlayOptions?.html\" [innerHTML]=\"overlayOptions.html\"></div><hi-overlay-content #overlayContent style=\"display: none\"></hi-overlay-content></div><hi-modal-backdrop [isOpen]=\"true\" [modalOptions]=\"overlayOptions\"></hi-modal-backdrop>\n  "
        }),
        __metadata("design:paramtypes", [WindowRef, Renderer2])
    ], OverlayComponent);
    return OverlayComponent;
}());
export { OverlayComponent };
