var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ComponentFactoryResolver, Injectable, Injector } from '@angular/core';
import { HiNGConfig } from '../hi.config';
import { OverlayComponent } from './overlay.component';
import { DomSanitizer } from '@angular/platform-browser';
var OverlayService = (function () {
    function OverlayService(hiNGConfig, componentFactoryResolver, injector, domSanitizer) {
        this.hiNGConfig = hiNGConfig;
        this.componentFactoryResolver = componentFactoryResolver;
        this.injector = injector;
        this.domSanitizer = domSanitizer;
        this.overlayCount = 0;
    }
    OverlayService.prototype.open = function (options) {
        if (!this.overlayCount++) {
            this.createOverlay(options);
        }
    };
    OverlayService.prototype.createOverlay = function (options) {
        var rootContainer = options.rootContainer || this.hiNGConfig.rootContainer;
        if (!rootContainer) {
            throw new Error('Should setup ViewContainerRef on modal overlay or hi config service!');
        }
        if (options.html && (typeof options.html === 'string')) {
            options.html = this.domSanitizer.bypassSecurityTrustHtml(options.html);
        }
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(OverlayComponent);
        var injector = options.injector || this.injector;
        this.overlayRef = rootContainer.createComponent(componentFactory, rootContainer.length, injector);
        var cmp = this.overlayRef.instance;
        cmp.addContent(options);
    };
    OverlayService.prototype.close = function () {
        this.overlayCount = this.overlayCount > 0 ? this.overlayCount - 1 : 0;
        if (this.overlayCount < 1 && this.overlayRef) {
            this.overlayRef.destroy();
        }
    };
    OverlayService = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [HiNGConfig, ComponentFactoryResolver,
            Injector, DomSanitizer])
    ], OverlayService);
    return OverlayService;
}());
export { OverlayService };
