var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, forwardRef, Input, ChangeDetectorRef, EventEmitter, Output } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { HiNGConfig } from '../hi.config';
var RadioGroupComponent = (function () {
    function RadioGroupComponent(hiNGConfig, changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.disabled = false;
        this.valueChange = new EventEmitter();
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.formatter = hiNGConfig.radioGroup.formatter;
        this.valueParser = hiNGConfig.radioGroup.valueParser;
        this.name = "hi-radio-group-" + RadioGroupComponent_1.NAME_SEED++;
    }
    RadioGroupComponent_1 = RadioGroupComponent;
    RadioGroupComponent.prototype.writeValue = function (obj) {
        this.value = obj;
        this.changeDetectorRef.markForCheck();
    };
    RadioGroupComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    RadioGroupComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    RadioGroupComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    RadioGroupComponent.prototype.onRadioChange = function (item) {
        this.onTouched();
        this.value = this.valueParser(item);
        this.onChange(this.value);
        this.valueChange.emit(this.value);
    };
    RadioGroupComponent.prototype.isChecked = function (item) {
        return this.value === this.valueParser(item);
    };
    var RadioGroupComponent_1;
    RadioGroupComponent.NAME_SEED = 0;
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], RadioGroupComponent.prototype, "disabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], RadioGroupComponent.prototype, "options", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], RadioGroupComponent.prototype, "inline", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], RadioGroupComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], RadioGroupComponent.prototype, "formatter", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], RadioGroupComponent.prototype, "valueParser", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], RadioGroupComponent.prototype, "valueChange", void 0);
    RadioGroupComponent = RadioGroupComponent_1 = __decorate([
        Component({
            selector: 'hi-radio-group',
            template: "\n    <div [ngClass]=\"{'radio-inline': inline, 'radio': !inline}\" *ngFor=\"let item of options\"><label><input type=\"radio\" [name]=\"name\" [value]=\"valueParser(item)\" [checked]=\"isChecked(item)\" [disabled]=\"disabled\" (change)=\"onRadioChange(item)\">{{formatter(item)}}</label></div>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            host: { '[class]': 'cssClass' },
            exportAs: 'radioGroup',
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return RadioGroupComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [HiNGConfig, ChangeDetectorRef])
    ], RadioGroupComponent);
    return RadioGroupComponent;
}());
export { RadioGroupComponent };
