var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, forwardRef, Input, ChangeDetectorRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { HiNGConfig } from '../hi.config';
var SelectButtonComponent = (function () {
    function SelectButtonComponent(changeDetectorRef, hiNGConfig) {
        this.changeDetectorRef = changeDetectorRef;
        this.disabled = false;
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.type = hiNGConfig.selectButton.type;
        this.justified = hiNGConfig.selectButton.justified;
        this.multiple = hiNGConfig.selectButton.multiple;
    }
    SelectButtonComponent_1 = SelectButtonComponent;
    SelectButtonComponent.prototype.writeValue = function (obj) {
        this.value = obj;
        this.changeDetectorRef.markForCheck();
    };
    SelectButtonComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    SelectButtonComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    SelectButtonComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    SelectButtonComponent.prototype.isSelected = function (item) {
        var itemValue = item.value || item.text;
        if (this.value) {
            return this.multiple ? this.value.indexOf(itemValue) !== -1 : this.value === itemValue;
        }
    };
    SelectButtonComponent.prototype.selectedItem = function (item) {
        this.onTouched();
        var itemValue = item.value || item.text;
        if (this.multiple) {
            return this.fillMultipleValue(itemValue);
        }
        this.fillSingleValue(itemValue);
    };
    SelectButtonComponent.prototype.fillSingleValue = function (itemValue) {
        if (this.value !== itemValue) {
            this.value = itemValue;
            this.onChange(this.value);
        }
    };
    SelectButtonComponent.prototype.fillMultipleValue = function (itemValue) {
        var value = this.value || [];
        if (value.indexOf(itemValue) === -1) {
            this.value = value.concat([itemValue]);
        }
        else {
            this.value = value.filter(function (item) {
                return item !== itemValue;
            });
        }
        this.onChange(this.value);
    };
    var SelectButtonComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectButtonComponent.prototype, "size", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectButtonComponent.prototype, "type", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SelectButtonComponent.prototype, "justified", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SelectButtonComponent.prototype, "multiple", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectButtonComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectButtonComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectButtonComponent.prototype, "disabled", void 0);
    SelectButtonComponent = SelectButtonComponent_1 = __decorate([
        Component({
            selector: 'hi-select-button',
            template: "\n    <div class=\"btn-group\" role=\"group\" *ngFor=\"let item of items\"><button type=\"button\" class=\"btn btn-{{type}}\" [ngClass]=\"{active: isSelected(item)}\" [disabled]=\"disabled\" (click)=\"selectedItem(item)\">{{item.text}}</button></div>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            host: {
                '[class]': '(cssClass || "") + " btn-group " + (size ? "btn-group-" + size : "") ',
                'role': 'group',
                'aria-label': 'Button_group'
            },
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return SelectButtonComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [ChangeDetectorRef, HiNGConfig])
    ], SelectButtonComponent);
    return SelectButtonComponent;
}());
export { SelectButtonComponent };
