var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { animate, state, style, transition, trigger } from '@angular/animations';
import { Component, ElementRef, EventEmitter, Input, Output, Renderer2, ViewChild } from '@angular/core';
var SelectTopControlComponent = (function () {
    function SelectTopControlComponent(renderer) {
        this.renderer = renderer;
        this._listTemplateOfOption = [];
        this.listOfCachedSelectedOption = [];
        this.isComposing = false;
        this.hiListOfSelectedValueChange = new EventEmitter();
        this.hiOnSearch = new EventEmitter();
        this.hiMode = 'default';
        this.hiShowSearch = false;
        this.hiDisabled = false;
        this.hiOpen = false;
    }
    Object.defineProperty(SelectTopControlComponent.prototype, "hiListOfSelectedValue", {
        get: function () {
            return this._listOfSelectedValue;
        },
        set: function (value) {
            this._listOfSelectedValue = value;
            this.updateListOfCachedOption();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectTopControlComponent.prototype, "hiListTemplateOfOption", {
        get: function () {
            return this._listTemplateOfOption;
        },
        set: function (value) {
            this._listTemplateOfOption = value;
            this.updateListOfCachedOption();
        },
        enumerable: true,
        configurable: true
    });
    SelectTopControlComponent.prototype.updateListOfCachedOption = function () {
        var _this = this;
        if (this.isSingleMode) {
            var selectedOption = this.hiListTemplateOfOption.find(function (o) { return _this.compareWith(o.hiValue, _this.hiListOfSelectedValue[0]); });
            if (selectedOption) {
                this.listOfCachedSelectedOption = [selectedOption];
            }
        }
        else {
            var listOfCachedOptionFromLatestTemplate_1 = this.hiListTemplateOfOption.filter(function (o) { return !!_this.hiListOfSelectedValue.find(function (v) { return _this.compareWith(v, o.hiValue); }); });
            var restSelectedValue_1 = this.hiListOfSelectedValue.filter(function (v) { return !listOfCachedOptionFromLatestTemplate_1.find(function (o) { return _this.compareWith(o.hiValue, v); }); });
            var listOfCachedOptionFromOld = this.listOfCachedSelectedOption.filter(function (o) { return restSelectedValue_1.find(function (v) { return _this.compareWith(o.hiValue, v); }); });
            this.listOfCachedSelectedOption = listOfCachedOptionFromLatestTemplate_1.concat(listOfCachedOptionFromOld);
        }
    };
    SelectTopControlComponent.prototype.setInputValue = function (value, emit) {
        this.inputValue = value;
        this.updateWidth();
        this.hiOnSearch.emit({ value: value, emit: emit });
    };
    Object.defineProperty(SelectTopControlComponent.prototype, "isSingleMode", {
        get: function () {
            return this.hiMode === 'default';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectTopControlComponent.prototype, "isMultipleOrTags", {
        get: function () {
            return this.hiMode === 'tags' || this.hiMode === 'multiple';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectTopControlComponent.prototype, "placeHolderDisplay", {
        get: function () {
            return this.inputValue || this.isComposing || this.hiListOfSelectedValue.length ? 'none' : 'block';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectTopControlComponent.prototype, "searchDisplay", {
        get: function () {
            return this.hiOpen ? 'block' : 'none';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectTopControlComponent.prototype, "selectedValueDisplay", {
        get: function () {
            var showSelectedValue = false;
            var opacity = 1;
            if (!this.hiShowSearch) {
                showSelectedValue = true;
            }
            else {
                if (this.hiOpen) {
                    showSelectedValue = !(this.inputValue || this.isComposing);
                    if (showSelectedValue) {
                        opacity = 0.4;
                    }
                }
                else {
                    showSelectedValue = true;
                }
            }
            return {
                display: showSelectedValue ? 'block' : 'none',
                opacity: "" + opacity
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectTopControlComponent.prototype, "singleValueLabel", {
        get: function () {
            return this.getPropertyFromValue(this.hiListOfSelectedValue[0], 'hiLabel');
        },
        enumerable: true,
        configurable: true
    });
    SelectTopControlComponent.prototype.focusOnInput = function () {
        var _this = this;
        setTimeout(function () {
            if (_this.inputElement) {
                _this.inputElement.nativeElement.focus();
            }
        });
    };
    SelectTopControlComponent.prototype.getPropertyFromValue = function (value, prop) {
        var _this = this;
        var targetOption = this.listOfCachedSelectedOption.find(function (item) { return _this.compareWith(item.hiValue, value); });
        return targetOption ? targetOption[prop] : '';
    };
    SelectTopControlComponent.prototype.isOptionDisplay = function (value) {
        return (this.hiMode === 'tags') || !!this.getPropertyFromValue(value, 'hiLabel');
    };
    SelectTopControlComponent.prototype.removeValueFormSelected = function (value) {
        if (this.hiDisabled || this.getPropertyFromValue(value, 'hiDisabled')) {
            return;
        }
        this._listOfSelectedValue = this.hiListOfSelectedValue.filter(function (item) { return item !== value; });
        this.hiListOfSelectedValueChange.emit(this.hiListOfSelectedValue);
    };
    SelectTopControlComponent.prototype.updateWidth = function () {
        if (this.isMultipleOrTags && this.inputElement) {
            if (this.inputValue || this.isComposing) {
                this.renderer.setStyle(this.inputElement.nativeElement, 'width', this.inputElement.nativeElement.scrollWidth + "px");
            }
            else {
                this.renderer.removeStyle(this.inputElement.nativeElement, 'width');
            }
        }
    };
    SelectTopControlComponent.prototype.onKeyDownInput = function (e) {
        var keyCode = e.keyCode;
        var eventTarget = e.target;
        if (this.isMultipleOrTags &&
            !eventTarget.value &&
            keyCode === 8) {
            e.preventDefault();
            if (this.hiListOfSelectedValue.length) {
                this.removeValueFormSelected(this.hiListOfSelectedValue[this.hiListOfSelectedValue.length - 1]);
            }
        }
    };
    __decorate([
        ViewChild('inputElement', { static: false }),
        __metadata("design:type", ElementRef)
    ], SelectTopControlComponent.prototype, "inputElement", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], SelectTopControlComponent.prototype, "hiListOfSelectedValueChange", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], SelectTopControlComponent.prototype, "hiOnSearch", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectTopControlComponent.prototype, "hiMode", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectTopControlComponent.prototype, "hiShowSearch", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectTopControlComponent.prototype, "hiDisabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectTopControlComponent.prototype, "hiPlaceHolder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectTopControlComponent.prototype, "hiOpen", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], SelectTopControlComponent.prototype, "compareWith", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], SelectTopControlComponent.prototype, "hiListOfSelectedValue", null);
    __decorate([
        Input(),
        __metadata("design:type", Array),
        __metadata("design:paramtypes", [Array])
    ], SelectTopControlComponent.prototype, "hiListTemplateOfOption", null);
    SelectTopControlComponent = __decorate([
        Component({
            selector: '[hi-select-top-control]',
            preserveWhitespaces: false,
            animations: [
                trigger('tagAnimation', [
                    state('*', style({ opacity: 1, transform: 'scale(1)' })),
                    transition('void => *', [
                        style({ opacity: 0, transform: 'scale(0)' }),
                        animate('150ms linear')
                    ]),
                    state('void', style({ opacity: 0, transform: 'scale(0)' })),
                    transition('* => void', [
                        style({ opacity: 1, transform: 'scale(1)' }),
                        animate('150ms linear')
                    ])
                ])
            ],
            template: "\n    <ng-template #inputTemplate>\n      <input\n        #inputElement\n        autocomplete=\"off\"\n        class=\"hi-select-search__field\"\n        (compositionstart)=\"isComposing = true\"\n        (compositionend)=\"isComposing = false\"\n        (input)=\"updateWidth()\"\n        (keydown)=\"onKeyDownInput($event)\"\n        [ngModel]=\"inputValue\"\n        (ngModelChange)=\"setInputValue($event,true)\"\n        [disabled]=\"hiDisabled\">\n    </ng-template>\n    <div\n      *ngIf=\"hiPlaceHolder\"\n      hi-select-unselectable\n      [style.display]=\"placeHolderDisplay\"\n      (click)=\"focusOnInput()\"\n      class=\"hi-select-selection__placeholder\">\n      {{ hiPlaceHolder }}\n    </div>\n    <!--single mode-->\n    <ng-container *ngIf=\"isSingleMode\">\n      <!--selected label-->\n      <div\n        *ngIf=\"hiListOfSelectedValue.length\"\n        class=\"hi-select-selection-selected-value\"\n        [attr.title]=\"hiListOfSelectedValue[0].hiLabel\"\n        [ngStyle]=\"selectedValueDisplay\">\n        {{ singleValueLabel }}\n      </div>\n      <!--show search-->\n      <div\n        *ngIf=\"hiShowSearch\"\n        [style.display]=\"searchDisplay\"\n        class=\"hi-select-search hi-select-search--inline\">\n        <div class=\"hi-select-search__field__wrap\">\n          <ng-template [ngTemplateOutlet]=\"inputTemplate\"></ng-template>\n          <span class=\"hi-select-search__field__mirror\">{{inputValue}}&nbsp;</span>\n        </div>\n      </div>\n    </ng-container>\n    <!--multiple or tags mode-->\n    <ul *ngIf=\"isMultipleOrTags\">\n      <ng-container *ngFor=\"let value of hiListOfSelectedValue\">\n        <li\n          *ngIf=\"isOptionDisplay(value)\"\n          [@tagAnimation]\n          [attr.title]=\"getPropertyFromValue(value,'hiLabel')\"\n          [class.hi-select-selection__choice__disabled]=\"getPropertyFromValue(value,'hiDisabled')\"\n          class=\"hi-select-selection__choice\">\n          <div class=\"hi-select-selection__choice__content\">{{ getPropertyFromValue(value, 'hiLabel') || value }}</div>\n          <span *ngIf=\"!getPropertyFromValue(value,'hiDisabled')\" class=\"hi-select-selection__choice__remove\" (click)=\"removeValueFormSelected(value)\"></span>\n        </li>\n      </ng-container>\n\n      <li class=\"hi-select-search hi-select-search--inline\">\n        <ng-template [ngTemplateOutlet]=\"inputTemplate\"></ng-template>\n      </li>\n    </ul>\n  ",
            host: {
                '[class.hi-select-selection__rendered]': 'true'
            }
        }),
        __metadata("design:paramtypes", [Renderer2])
    ], SelectTopControlComponent);
    return SelectTopControlComponent;
}());
export { SelectTopControlComponent };
