import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange } from '@angular/cdk/overlay';
import { AfterViewInit, EventEmitter, OnDestroy, OnInit, QueryList, Renderer2 } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { OptionContainerComponent } from './option-container.component';
import { OptionGroupComponent } from './option-group.component';
import { OptionComponent } from './option.component';
import { TFilterOption } from './option.pipe';
import { SelectTopControlComponent } from './select-top-control.component';
export declare class SelectComponent implements ControlValueAccessor, OnInit, AfterViewInit, OnDestroy {
    private renderer;
    private _disabled;
    private _allowClear;
    private _showSearch;
    private _open;
    private _placeholder;
    private _autoFocus;
    private _dropdownClassName;
    onChange: (value: string | string[]) => void;
    onTouched: () => void;
    dropDownPosition: 'top' | 'center' | 'bottom';
    listOfSelectedValue: any[];
    listOfTemplateOption: OptionComponent[];
    value: any | any[];
    overlayWidth: number;
    overlayMinWidth: number;
    searchValue: string;
    isDestroy: boolean;
    isInit: boolean;
    dropDownClassMap: any;
    cdkOverlayOrigin: CdkOverlayOrigin;
    cdkConnectedOverlay: CdkConnectedOverlay;
    hiSelectTopControlComponent: SelectTopControlComponent;
    hiOptionContainerComponent: OptionContainerComponent;
    listOfHiOptionComponent: QueryList<OptionComponent>;
    listOfHiOptionGroupComponent: QueryList<OptionGroupComponent>;
    hiOnSearch: EventEmitter<string>;
    hiScrollToBottom: EventEmitter<void>;
    hiOpenChange: EventEmitter<boolean>;
    hiSize: string;
    hiServerSearch: boolean;
    hiMode: 'default' | 'multiple' | 'tags';
    hiDropdownMatchSelectWidth: boolean;
    hiFilterOption: TFilterOption;
    hiMaxMultipleCount: number;
    hiDropdownStyle: {
        [key: string]: string;
    };
    hiNotFoundContent: string;
    compareWith: (o1: any, o2: any) => boolean;
    hiDropdownClassName: string;
    hiAutoFocus: boolean;
    hiOpen: boolean;
    hiDisabled: boolean;
    hiAllowClear: boolean;
    hiShowSearch: boolean;
    hiPlaceHolder: string;
    onClick(): void;
    updateAutoFocus(): void;
    focus(): void;
    blur(): void;
    handleEscBug(): void;
    onKeyDownCdkOverlayOrigin(e: KeyboardEvent): void;
    closeDropDown(): void;
    onPositionChange(position: ConnectedOverlayPositionChange): void;
    onClickOptionFromOptionContainer(): void;
    updateCdkConnectedOverlayStatus(): void;
    updateCdkConnectedOverlayPositions(): void;
    readonly isSingleMode: boolean;
    readonly isMultipleOrTags: boolean;
    updateListOfSelectedValueFromOptionContainer(value: any[]): void;
    updateListOfSelectedValueFromTopControl(value: any[]): void;
    updateFromSelectedList(value: any[]): void;
    onSearch(value: string, emit: boolean): void;
    clearNgModel(): void;
    updateNgModel(list: any[], value: string | string[]): void;
    listOfTemplateOptionChange(value: OptionComponent[]): void;
    updateDropDownClassMap(): void;
    onClearSelection(e: MouseEvent): void;
    clearSearchValue(): void;
    constructor(renderer: Renderer2);
    writeValue(value: any | any[]): void;
    registerOnChange(fn: (value: string | string[]) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
