var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { animate, state, style, transition, trigger } from '@angular/animations';
import { CdkConnectedOverlay, CdkOverlayOrigin } from '@angular/cdk/overlay';
import { forwardRef, Component, ContentChildren, EventEmitter, HostListener, Input, Output, QueryList, Renderer2, SimpleChange, ViewChild, ViewEncapsulation } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { isNotNil } from '../utils/check';
import { toBoolean } from '../utils/convert';
import { OptionContainerComponent } from './option-container.component';
import { OptionGroupComponent } from './option-group.component';
import { OptionComponent } from './option.component';
import { defaultFilterOption } from './option.pipe';
import { SelectTopControlComponent } from './select-top-control.component';
var SelectComponent = (function () {
    function SelectComponent(renderer) {
        this.renderer = renderer;
        this._disabled = false;
        this._allowClear = false;
        this._showSearch = false;
        this._open = false;
        this._autoFocus = false;
        this.onChange = function () { return null; };
        this.onTouched = function () { return null; };
        this.dropDownPosition = 'bottom';
        this.listOfSelectedValue = [];
        this.listOfTemplateOption = [];
        this.searchValue = '';
        this.isDestroy = true;
        this.isInit = false;
        this.hiOnSearch = new EventEmitter();
        this.hiScrollToBottom = new EventEmitter();
        this.hiOpenChange = new EventEmitter();
        this.hiSize = 'default';
        this.hiServerSearch = false;
        this.hiMode = 'default';
        this.hiDropdownMatchSelectWidth = true;
        this.hiFilterOption = defaultFilterOption;
        this.hiMaxMultipleCount = Infinity;
        this.compareWith = function (o1, o2) { return o1 === o2; };
    }
    SelectComponent_1 = SelectComponent;
    Object.defineProperty(SelectComponent.prototype, "hiDropdownClassName", {
        get: function () {
            return this._dropdownClassName;
        },
        set: function (value) {
            this._dropdownClassName = value;
            this.updateDropDownClassMap();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hiAutoFocus", {
        get: function () {
            return this._autoFocus;
        },
        set: function (value) {
            this._autoFocus = toBoolean(value);
            this.updateAutoFocus();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hiOpen", {
        get: function () {
            return this._open;
        },
        set: function (value) {
            this._open = value;
            this.handleEscBug();
            this.updateCdkConnectedOverlayStatus();
            this.updateDropDownClassMap();
            if (this.hiOpen) {
                if (this.hiSelectTopControlComponent) {
                    this.hiSelectTopControlComponent.focusOnInput();
                    this.hiSelectTopControlComponent.setInputValue('', true);
                }
                if (this.hiOptionContainerComponent) {
                    this.hiOptionContainerComponent.scrollIntoView();
                }
                if (this.cdkConnectedOverlay && this.cdkConnectedOverlay.overlayRef) {
                    this.cdkConnectedOverlay.overlayRef.updatePosition();
                }
            }
            else {
                if (this.hiSelectTopControlComponent) {
                    this.hiSelectTopControlComponent.setInputValue('', false);
                }
                if (this.hiOptionContainerComponent) {
                    this.hiOptionContainerComponent.resetActiveOption();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hiDisabled", {
        get: function () {
            return this._disabled;
        },
        set: function (value) {
            this._disabled = toBoolean(value);
            if (this.hiDisabled) {
                this.closeDropDown();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hiAllowClear", {
        get: function () {
            return this._allowClear;
        },
        set: function (value) {
            this._allowClear = toBoolean(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hiShowSearch", {
        get: function () {
            return this._showSearch;
        },
        set: function (value) {
            this._showSearch = toBoolean(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "hiPlaceHolder", {
        get: function () {
            return this._placeholder;
        },
        set: function (value) {
            this._placeholder = value;
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.onClick = function () {
        if (!this.hiDisabled) {
            this.hiOpen = !this.hiOpen;
            this.hiOpenChange.emit(this.hiOpen);
        }
    };
    SelectComponent.prototype.updateAutoFocus = function () {
        if (this.isInit && this.hiSelectTopControlComponent.inputElement) {
            if (this.hiAutoFocus) {
                this.renderer.setAttribute(this.hiSelectTopControlComponent.inputElement.nativeElement, 'autofocus', 'autofocus');
            }
            else {
                this.renderer.removeAttribute(this.hiSelectTopControlComponent.inputElement.nativeElement, 'autofocus');
            }
        }
    };
    SelectComponent.prototype.focus = function () {
        if (this.hiSelectTopControlComponent.inputElement) {
            this.hiSelectTopControlComponent.inputElement.nativeElement.focus();
        }
    };
    SelectComponent.prototype.blur = function () {
        if (this.hiSelectTopControlComponent.inputElement) {
            this.hiSelectTopControlComponent.inputElement.nativeElement.blur();
        }
    };
    SelectComponent.prototype.handleEscBug = function () {
        if (this.hiOpen && this.cdkConnectedOverlay && this.cdkConnectedOverlay.overlayRef && !this.cdkConnectedOverlay.overlayRef.backdropElement) {
            this.cdkConnectedOverlay.open = true;
            this.cdkConnectedOverlay.ngOnChanges({ open: new SimpleChange(false, true, false) });
        }
    };
    SelectComponent.prototype.onKeyDownCdkOverlayOrigin = function (e) {
        if (this.hiOptionContainerComponent) {
            this.hiOptionContainerComponent.onKeyDownUl(e);
        }
    };
    SelectComponent.prototype.closeDropDown = function () {
        if (this.hiOpen) {
            this.onTouched();
            this.hiOpen = false;
            this.hiOpenChange.emit(this.hiOpen);
        }
    };
    SelectComponent.prototype.onPositionChange = function (position) {
        this.dropDownPosition = position.connectionPair.originY;
        this.updateDropDownClassMap();
    };
    SelectComponent.prototype.onClickOptionFromOptionContainer = function () {
        if (this.isSingleMode) {
            this.closeDropDown();
        }
        else if (this.hiMode === 'tags') {
            this.onSearch('', true);
        }
    };
    SelectComponent.prototype.updateCdkConnectedOverlayStatus = function () {
        if (this.isInit && this.hiOpen && this.cdkOverlayOrigin) {
            if (this.hiDropdownMatchSelectWidth) {
                this.overlayWidth = this.cdkOverlayOrigin.elementRef.nativeElement.getBoundingClientRect().width;
                this.cdkConnectedOverlay.overlayRef.updateSize({ width: this.overlayWidth });
            }
            else {
                this.overlayMinWidth = this.cdkOverlayOrigin.elementRef.nativeElement.getBoundingClientRect().width;
                this.cdkConnectedOverlay.overlayRef.updateSize({ minWidth: this.overlayMinWidth });
            }
        }
        this.updateCdkConnectedOverlayPositions();
        if (this.cdkConnectedOverlay && this.cdkConnectedOverlay.overlayRef && this.cdkConnectedOverlay.overlayRef.backdropElement) {
            if (this.hiOpen) {
                this.renderer.removeStyle(this.cdkConnectedOverlay.overlayRef.backdropElement, 'display');
            }
            else {
                this.renderer.setStyle(this.cdkConnectedOverlay.overlayRef.backdropElement, 'display', 'none');
            }
        }
    };
    SelectComponent.prototype.updateCdkConnectedOverlayPositions = function () {
        var _this = this;
        setTimeout(function () { return _this.cdkConnectedOverlay.overlayRef.updatePosition(); }, 160);
    };
    Object.defineProperty(SelectComponent.prototype, "isSingleMode", {
        get: function () {
            return this.hiMode === 'default';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectComponent.prototype, "isMultipleOrTags", {
        get: function () {
            return this.hiMode === 'tags' || this.hiMode === 'multiple';
        },
        enumerable: true,
        configurable: true
    });
    SelectComponent.prototype.updateListOfSelectedValueFromOptionContainer = function (value) {
        this.clearSearchValue();
        this.updateFromSelectedList(value);
    };
    SelectComponent.prototype.updateListOfSelectedValueFromTopControl = function (value) {
        this.clearSearchValue();
        this.updateFromSelectedList(value);
    };
    SelectComponent.prototype.updateFromSelectedList = function (value) {
        var modelValue;
        if (this.isSingleMode) {
            if (value.length) {
                modelValue = value[0];
            }
        }
        else {
            modelValue = value;
            this.updateCdkConnectedOverlayPositions();
        }
        this.updateNgModel(value, modelValue);
    };
    SelectComponent.prototype.onSearch = function (value, emit) {
        if (emit && (this.searchValue !== value)) {
            this.hiOnSearch.emit(value);
            this.searchValue = value;
        }
    };
    SelectComponent.prototype.clearNgModel = function () {
        if (this.isSingleMode) {
            this.updateNgModel([], null);
        }
        else {
            this.updateNgModel([], []);
        }
    };
    SelectComponent.prototype.updateNgModel = function (list, value) {
        this.listOfSelectedValue = list;
        if (value !== this.value) {
            this.value = value;
            this.onChange(this.value);
        }
    };
    SelectComponent.prototype.listOfTemplateOptionChange = function (value) {
        this.listOfTemplateOption = value;
    };
    SelectComponent.prototype.updateDropDownClassMap = function () {
        var _a;
        this.dropDownClassMap = (_a = {},
            _a['hi-select-dropdown'] = true,
            _a["hi-select-dropdown--single"] = this.isSingleMode,
            _a["hi-select-dropdown--multiple"] = this.isMultipleOrTags,
            _a["hi-select-dropdown-placement-bottomLeft"] = this.dropDownPosition === 'bottom',
            _a["hi-select-dropdown-placement-topLeft"] = this.dropDownPosition === 'top',
            _a["" + this.hiDropdownClassName] = !!this.hiDropdownClassName,
            _a);
    };
    SelectComponent.prototype.onClearSelection = function (e) {
        e.stopPropagation();
        this.clearNgModel();
    };
    SelectComponent.prototype.clearSearchValue = function () {
        if (this.isSingleMode) {
            this.hiSelectTopControlComponent.setInputValue('', false);
        }
        else {
            this.hiSelectTopControlComponent.setInputValue('', false);
        }
    };
    SelectComponent.prototype.writeValue = function (value) {
        this.value = value;
        if (isNotNil(value)) {
            if (Array.isArray(value)) {
                this.listOfSelectedValue = value;
            }
            else {
                this.listOfSelectedValue = [value];
            }
        }
        else {
            this.listOfSelectedValue = [];
        }
    };
    SelectComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    SelectComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    SelectComponent.prototype.setDisabledState = function (isDisabled) {
        this.hiDisabled = isDisabled;
    };
    SelectComponent.prototype.ngOnInit = function () {
        this.isDestroy = false;
        this.updateDropDownClassMap();
    };
    SelectComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.isInit = true;
        Promise.resolve().then(function () { return _this.updateCdkConnectedOverlayStatus(); });
    };
    SelectComponent.prototype.ngOnDestroy = function () {
        this.isDestroy = true;
    };
    var SelectComponent_1;
    __decorate([
        ViewChild(CdkOverlayOrigin, { static: false }),
        __metadata("design:type", CdkOverlayOrigin)
    ], SelectComponent.prototype, "cdkOverlayOrigin", void 0);
    __decorate([
        ViewChild(CdkConnectedOverlay, { static: false }),
        __metadata("design:type", CdkConnectedOverlay)
    ], SelectComponent.prototype, "cdkConnectedOverlay", void 0);
    __decorate([
        ViewChild(SelectTopControlComponent, { static: false }),
        __metadata("design:type", SelectTopControlComponent)
    ], SelectComponent.prototype, "hiSelectTopControlComponent", void 0);
    __decorate([
        ViewChild(OptionContainerComponent, { static: false }),
        __metadata("design:type", OptionContainerComponent)
    ], SelectComponent.prototype, "hiOptionContainerComponent", void 0);
    __decorate([
        ContentChildren(OptionComponent),
        __metadata("design:type", QueryList)
    ], SelectComponent.prototype, "listOfHiOptionComponent", void 0);
    __decorate([
        ContentChildren(OptionGroupComponent),
        __metadata("design:type", QueryList)
    ], SelectComponent.prototype, "listOfHiOptionGroupComponent", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiOnSearch", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiScrollToBottom", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiOpenChange", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiServerSearch", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "hiMode", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiDropdownMatchSelectWidth", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], SelectComponent.prototype, "hiFilterOption", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiMaxMultipleCount", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "hiDropdownStyle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SelectComponent.prototype, "hiNotFoundContent", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], SelectComponent.prototype, "compareWith", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], SelectComponent.prototype, "hiDropdownClassName", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], SelectComponent.prototype, "hiAutoFocus", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], SelectComponent.prototype, "hiOpen", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], SelectComponent.prototype, "hiDisabled", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], SelectComponent.prototype, "hiAllowClear", null);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], SelectComponent.prototype, "hiShowSearch", null);
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], SelectComponent.prototype, "hiPlaceHolder", null);
    __decorate([
        HostListener('click'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], SelectComponent.prototype, "onClick", null);
    SelectComponent = SelectComponent_1 = __decorate([
        Component({
            selector: 'hi-select',
            preserveWhitespaces: false,
            providers: [
                {
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return SelectComponent_1; }),
                    multi: true
                }
            ],
            animations: [
                trigger('dropDownAnimation', [
                    state('hidden', style({
                        opacity: 0,
                        display: 'none'
                    })),
                    state('bottom', style({
                        opacity: 1,
                        transform: 'scaleY(1)',
                        transformOrigin: '0% 0%'
                    })),
                    state('top', style({
                        opacity: 1,
                        transform: 'scaleY(1)',
                        transformOrigin: '0% 100%'
                    })),
                    transition('hidden => bottom', [
                        style({
                            opacity: 0,
                            transform: 'scaleY(0.8)',
                            transformOrigin: '0% 0%'
                        }),
                        animate('100ms cubic-bezier(0.755, 0.05, 0.855, 0.06)')
                    ]),
                    transition('bottom => hidden', [
                        animate('100ms cubic-bezier(0.755, 0.05, 0.855, 0.06)', style({
                            opacity: 0,
                            transform: 'scaleY(0.8)',
                            transformOrigin: '0% 0%'
                        }))
                    ]),
                    transition('hidden => top', [
                        style({
                            opacity: 0,
                            transform: 'scaleY(0.8)',
                            transformOrigin: '0% 100%'
                        }),
                        animate('100ms cubic-bezier(0.755, 0.05, 0.855, 0.06)')
                    ]),
                    transition('top => hidden', [
                        animate('100ms cubic-bezier(0.755, 0.05, 0.855, 0.06)', style({
                            opacity: 0,
                            transform: 'scaleY(0.8)',
                            transformOrigin: '0% 100%'
                        }))
                    ])
                ])
            ],
            template: "\n      <div\n        cdkOverlayOrigin\n        class=\"hi-select-selection\"\n        [class.hi-select-selection--single]=\"isSingleMode\"\n        [class.hi-select-selection--multiple]=\"isMultipleOrTags\"\n        (keydown)=\"onKeyDownCdkOverlayOrigin($event)\"\n        tabindex=\"0\">\n        <div\n          hi-select-top-control\n          [hiOpen]=\"hiOpen\"\n          [compareWith]=\"compareWith\"\n          [hiPlaceHolder]=\"hiPlaceHolder\"\n          [hiShowSearch]=\"hiShowSearch\"\n          [hiDisabled]=\"hiDisabled\"\n          [hiMode]=\"hiMode\"\n          [hiListTemplateOfOption]=\"listOfTemplateOption\"\n          [hiListOfSelectedValue]=\"listOfSelectedValue\"\n          (hiOnSearch)=\"onSearch($event.value,$event.emit)\"\n          (hiListOfSelectedValueChange)=\"updateListOfSelectedValueFromTopControl($event)\">\n        </div>\n        <span *ngIf=\"hiAllowClear\" class=\"hi-select-selection__clear\" hi-select-unselectable (click)=\"onClearSelection($event)\"></span>\n        <span class=\"hi-select-arrow\" hi-select-unselectable><b></b></span>\n      </div>\n      <ng-template\n        cdkConnectedOverlay\n        [cdkConnectedOverlayHasBackdrop]=\"true\"\n        [cdkConnectedOverlayOrigin]=\"cdkOverlayOrigin\"\n        (backdropClick)=\"closeDropDown()\"\n        (detach)=\"closeDropDown();\"\n        (positionChange)=\"onPositionChange($event)\"\n        [cdkConnectedOverlayWidth]=\"overlayWidth\"\n        [cdkConnectedOverlayMinWidth]=\"overlayMinWidth\"\n        [cdkConnectedOverlayOpen]=\"!isDestroy\">\n        <div [ngClass]=\"dropDownClassMap\" [@dropDownAnimation]=\"hiOpen ? dropDownPosition : 'hidden' \" [ngStyle]=\"hiDropdownStyle\">\n          <div\n            style=\"overflow: auto\"\n            hi-option-container\n            [listOfHiOptionComponent]=\"listOfHiOptionComponent\"\n            [listOfHiOptionGroupComponent]=\"listOfHiOptionGroupComponent\"\n            [hiSearchValue]=\"searchValue\"\n            [hiFilterOption]=\"hiFilterOption\"\n            [hiServerSearch]=\"hiServerSearch\"\n            [compareWith]=\"compareWith\"\n            [hiNotFoundContent]=\"hiNotFoundContent\"\n            [hiMaxMultipleCount]=\"hiMaxMultipleCount\"\n            [hiMode]=\"hiMode\"\n            (hiScrollToBottom)=\"hiScrollToBottom.emit()\"\n            (hiClickOption)=\"onClickOptionFromOptionContainer()\"\n            (hiListOfTemplateOptionChange)=\"listOfTemplateOptionChange($event)\"\n            (hiListOfSelectedValueChange)=\"updateListOfSelectedValueFromOptionContainer($event)\"\n            [hiListOfSelectedValue]=\"listOfSelectedValue\">\n          </div>\n        </div>\n      </ng-template>\n      <!--can not use ViewChild since it will match sub options in option group -->\n      <ng-template>\n        <ng-content></ng-content>\n      </ng-template>\n    ",
            host: {
                '[class.hi-select]': 'true',
                '[class.hi-select-lg]': 'hiSize==="large"',
                '[class.hi-select-sm]': 'hiSize==="small"',
                '[class.hi-select-enabled]': '!hiDisabled',
                '[class.hi-select-disabled]': 'hiDisabled',
                '[class.hi-select-allow-clear]': 'hiAllowClear',
                '[class.hi-select-open]': 'hiOpen'
            },
            styles: ["\n      .cdk-overlay-container{pointer-events:none;top:0;left:0;height:100%;width:100%;position:fixed;z-index:1000}.cdk-overlay-backdrop{top:0;bottom:0;left:0;right:0;-webkit-tap-highlight-color:transparent;-webkit-transition:opacity .4s cubic-bezier(.25,.8,.25,1);transition:opacity .4s cubic-bezier(.25,.8,.25,1);opacity:0}.cdk-overlay-backdrop,.cdk-overlay-pane{position:absolute;pointer-events:auto;z-index:1000}@font-face{font-family:anticon;src:url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.eot);src:url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.eot#iefix) format(\"embedded-opentype\"),url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.woff) format(\"woff\"),url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.ttf) format(\"truetype\"),url(https://at.alicdn.com/t/font_zck90zmlh7hf47vi.svg#iconfont) format(\"svg\")}.hi-select-auto-complete{font-family:Monospaced Number,Chinese Quote,-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,PingFang SC,Hiragino Sans GB,Microsoft YaHei,Helvetica Neue,Helvetica,Arial,sans-serif;font-size:14px;line-height:1.5;color:rgba(0,0,0,.65);-webkit-box-sizing:border-box;box-sizing:border-box;margin:0;padding:0;list-style:none}.hi-select-auto-complete.hi-select .hi-select-selection{border:0;-webkit-box-shadow:none;box-shadow:none}.hi-select-auto-complete.hi-select .hi-select-selection__rendered{margin-left:0;margin-right:0;height:100%;line-height:32px}.hi-select-auto-complete.hi-select .hi-select-selection__placeholder{margin-left:12px;margin-right:12px}.hi-select-auto-complete.hi-select .hi-select-selection--single{height:auto}.hi-select-auto-complete.hi-select .hi-select-search--inline{position:static;float:left}.hi-select-auto-complete.hi-select-allow-clear .hi-select-selection:hover .hi-select-selection__rendered{margin-right:0!important}.hi-select-auto-complete.hi-select .hi-input{background:0 0;border-width:1px;line-height:1.5;height:32px}.hi-select-auto-complete.hi-select .hi-input:focus,.hi-select-auto-complete.hi-select .hi-input:hover{border-color:#28a745;border-right-width:1px!important}.hi-select-auto-complete.hi-select-lg .hi-select-selection__rendered{line-height:40px}.hi-select-auto-complete.hi-select-lg .hi-input{padding-top:6px;padding-bottom:6px;height:40px}.hi-select-auto-complete.hi-select-sm .hi-select-selection__rendered{line-height:24px}.hi-select-auto-complete.hi-select-sm .hi-input{padding-top:1px;padding-bottom:1px;height:24px}.hi-select{font-family:Monospaced Number,Chinese Quote,-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,PingFang SC,Hiragino Sans GB,Microsoft YaHei,Helvetica Neue,Helvetica,Arial,sans-serif;font-size:14px;line-height:1.5;color:rgba(0,0,0,.65);-webkit-box-sizing:border-box;box-sizing:border-box;display:inline-block;position:relative}.hi-select,.hi-select ol,.hi-select ul{margin:0;padding:0;list-style:none}.hi-select>ul>li>a{padding:0;background-color:#fff}.hi-select-arrow{display:inline-block;font-style:normal;vertical-align:baseline;text-align:center;text-transform:none;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale;position:absolute;top:50%;right:11px;line-height:1;margin-top:-6px;-webkit-transform-origin:50% 50%;-ms-transform-origin:50% 50%;transform-origin:50% 50%;color:rgba(0,0,0,.25);font-size:12px}.hi-select-arrow:before{display:block;font-family:anticon!important}.hi-select-arrow *{display:none}.hi-select-arrow:before{content:\"\\E61D\";-webkit-transition:-webkit-transform .3s;transition:-webkit-transform .3s;transition:transform .3s;transition:transform .3s,-webkit-transform .3s}.hi-select-selection{outline:0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-box-sizing:border-box;box-sizing:border-box;display:block;background-color:#fff;border-radius:4px;border:1px solid #d9d9d9;border-top-width:1.02px;-webkit-transition:all .3s cubic-bezier(.645,.045,.355,1);transition:all .3s cubic-bezier(.645,.045,.355,1)}.hi-select-selection:hover{border-color:#28a745;border-right-width:1px!important}.hi-select-focused .hi-select-selection,.hi-select-selection:active,.hi-select-selection:focus{border-color:#28a745;outline:0;-webkit-box-shadow:0 0 0 2px rgba(24,144,255,.2);box-shadow:0 0 0 2px rgba(24,144,255,.2);border-right-width:1px!important}.hi-select-selection__clear{display:inline-block;font-style:normal;vertical-align:baseline;text-align:center;text-transform:none;text-rendering:auto;opacity:0;position:absolute;right:11px;z-index:1;background:#fff;top:50%;font-size:12px;color:rgba(0,0,0,.25);width:12px;height:12px;margin-top:-6px;line-height:12px;cursor:pointer;-webkit-transition:color .3s ease,opacity .15s ease;transition:color .3s ease,opacity .15s ease}.hi-select-selection__clear:before{display:block;font-family:anticon;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale;content:\"\\E62E\"}.hi-select-selection__clear:hover{color:rgba(0,0,0,.45)}.hi-select-selection:hover .hi-select-selection__clear{opacity:1}.hi-select-selection-selected-value{float:left;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;max-width:100%;padding-right:20px}.hi-select-no-arrow .hi-select-selection-selected-value{padding-right:0}.hi-select-disabled{color:rgba(0,0,0,.25)}.hi-select-disabled .hi-select-selection{background:#f5f5f5;cursor:not-allowed}.hi-select-disabled .hi-select-selection:active,.hi-select-disabled .hi-select-selection:focus,.hi-select-disabled .hi-select-selection:hover{border-color:#d9d9d9;-webkit-box-shadow:none;box-shadow:none}.hi-select-disabled .hi-select-selection__clear{display:none;visibility:hidden;pointer-events:none}.hi-select-disabled .hi-select-selection--multiple .hi-select-selection__choice{background:#f5f5f5;color:#aaa;padding-right:10px}.hi-select-disabled .hi-select-selection--multiple .hi-select-selection__choice__remove{display:none}.hi-select-selection--single{height:32px;position:relative;cursor:pointer}.hi-select-selection__rendered{display:block;margin-left:11px;margin-right:11px;position:relative;line-height:30px}.hi-select-selection__rendered:after{content:\".\";visibility:hidden;pointer-events:none;display:inline-block;width:0}.hi-select-lg{font-size:16px}.hi-select-lg .hi-select-selection--single{height:40px}.hi-select-lg .hi-select-selection__rendered{line-height:38px}.hi-select-lg .hi-select-selection--multiple{min-height:40px}.hi-select-lg .hi-select-selection--multiple .hi-select-selection__rendered li{height:32px;line-height:32px}.hi-select-lg .hi-select-selection--multiple .hi-select-selection__clear{top:20px}.hi-select-sm .hi-select-selection--single{height:24px}.hi-select-sm .hi-select-selection__rendered{line-height:22px;margin:0 7px}.hi-select-sm .hi-select-selection--multiple{min-height:24px}.hi-select-sm .hi-select-selection--multiple .hi-select-selection__rendered li{height:16px;line-height:14px}.hi-select-sm .hi-select-selection--multiple .hi-select-selection__clear{top:12px}.hi-select-sm .hi-select-arrow,.hi-select-sm .hi-select-selection__clear{right:8px}.hi-select-disabled .hi-select-selection__choice__remove{color:rgba(0,0,0,.25);cursor:default}.hi-select-disabled .hi-select-selection__choice__remove:hover{color:rgba(0,0,0,.25)}.hi-select-search__field__wrap{display:inline-block;position:relative}.hi-select-search__field__placeholder,.hi-select-selection__placeholder{position:absolute;top:50%;left:0;right:9px;color:#bfbfbf;line-height:20px;height:20px;max-width:100%;margin-top:-10px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;text-align:left}.hi-select-search__field__placeholder{left:12px}.hi-select-search__field__mirror{position:absolute;top:0;left:-9999px;white-space:pre;pointer-events:none}.hi-select-search--inline{position:absolute;height:100%;width:100%}.hi-select-search--inline .hi-select-search__field__wrap{width:100%;height:100%}.hi-select-search--inline .hi-select-search__field{border-width:0;font-size:100%;height:100%;width:100%;background:0 0;outline:0;border-radius:4px;line-height:1}.hi-select-search--inline>i{float:right}.hi-select-selection--multiple{min-height:32px;cursor:text;padding-bottom:3px;zoom:1}.hi-select-selection--multiple:after,.hi-select-selection--multiple:before{content:\"\";display:table}.hi-select-selection--multiple:after{clear:both}.hi-select-selection--multiple .hi-select-search--inline{float:left;position:static;width:auto;padding:0;max-width:100%}.hi-select-selection--multiple .hi-select-search--inline .hi-select-search__field{max-width:100%;width:.75em}.hi-select-selection--multiple .hi-select-selection__rendered{margin-left:5px;margin-bottom:-3px;height:auto}.hi-select-selection--multiple .hi-select-selection__placeholder{margin-left:6px}.hi-select-selection--multiple .hi-select-selection__rendered>ul>li,.hi-select-selection--multiple>ul>li{margin-top:3px;height:24px;line-height:22px}.hi-select-selection--multiple .hi-select-selection__choice{color:rgba(0,0,0,.65);background-color:#fafafa;border:1px solid #e8e8e8;border-radius:2px;cursor:default;float:left;margin-right:4px;max-width:99%;position:relative;overflow:hidden;-webkit-transition:padding .3s cubic-bezier(.645,.045,.355,1);transition:padding .3s cubic-bezier(.645,.045,.355,1);padding:0 20px 0 10px}.hi-select-selection--multiple .hi-select-selection__choice__disabled{padding:0 10px}.hi-select-selection--multiple .hi-select-selection__choice__content{display:inline-block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;max-width:100%;-webkit-transition:margin .3s cubic-bezier(.645,.045,.355,1);transition:margin .3s cubic-bezier(.645,.045,.355,1)}.hi-select-selection--multiple .hi-select-selection__choice__remove{font-style:normal;vertical-align:baseline;text-align:center;text-transform:none;line-height:1;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale;color:rgba(0,0,0,.45);line-height:inherit;cursor:pointer;font-weight:700;-webkit-transition:all .3s;transition:all .3s;display:inline-block;font-size:12px;font-size:10px\\9;-webkit-transform:scale(.83333) rotate(0);-ms-transform:scale(.83333) rotate(0);transform:scale(.83333) rotate(0);position:absolute;right:4px}.hi-select-selection--multiple .hi-select-selection__choice__remove:before{display:block;font-family:anticon!important}:root .hi-select-selection--multiple .hi-select-selection__choice__remove{font-size:12px}.hi-select-selection--multiple .hi-select-selection__choice__remove:hover{color:#404040}.hi-select-selection--multiple .hi-select-selection__choice__remove:before{content:\"\\E633\"}.hi-select-selection--multiple .hi-select-selection__clear{top:16px}.hi-select-allow-clear .hi-select-selection--single .hi-select-selection-selected-value{padding-right:16px}.hi-select-allow-clear .hi-select-selection--multiple .hi-select-selection__rendered{margin-right:20px}.hi-select-open .hi-select-arrow:before{-webkit-transform:rotate(180deg);-ms-transform:rotate(180deg);transform:rotate(180deg)}.hi-select-open .hi-select-selection{border-color:#28a745;outline:0;-webkit-box-shadow:0 0 0 2px #effaef;box-shadow:0 0 0 2px #effaef;border-right-width:1px!important}.hi-select-combobox .hi-select-arrow{display:none}.hi-select-combobox .hi-select-search--inline{height:100%;width:100%;float:none}.hi-select-combobox .hi-select-search__field__wrap{width:100%;height:100%}.hi-select-combobox .hi-select-search__field{width:100%;height:100%;position:relative;z-index:1;-webkit-transition:all .3s cubic-bezier(.645,.045,.355,1);transition:all .3s cubic-bezier(.645,.045,.355,1);-webkit-box-shadow:none;box-shadow:none}.hi-select-combobox.hi-select-allow-clear .hi-select-selection:hover .hi-select-selection__rendered{margin-right:20px}.hi-select-dropdown{font-family:Monospaced Number,Chinese Quote,-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,PingFang SC,Hiragino Sans GB,Microsoft YaHei,Helvetica Neue,Helvetica,Arial,sans-serif;line-height:1.5;color:rgba(0,0,0,.65);margin:0;padding:0;list-style:none;background-color:#fff;-webkit-box-shadow:0 2px 8px rgba(0,0,0,.15);box-shadow:0 2px 8px rgba(0,0,0,.15);border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;z-index:1050;top:100%;left:0;position:relative;width:100%;margin-top:4px;margin-bottom:4px;outline:0;font-size:14px}.hi-select-dropdown.slide-up-appear.slide-up-appear-active.hi-select-dropdown-placement-bottomLeft,.hi-select-dropdown.slide-up-enter.slide-up-enter-active.hi-select-dropdown-placement-bottomLeft{-webkit-animation-name:antSlideUpIn;animation-name:antSlideUpIn}.hi-select-dropdown.slide-up-appear.slide-up-appear-active.hi-select-dropdown-placement-topLeft,.hi-select-dropdown.slide-up-enter.slide-up-enter-active.hi-select-dropdown-placement-topLeft{-webkit-animation-name:antSlideDownIn;animation-name:antSlideDownIn}.hi-select-dropdown.slide-up-leave.slide-up-leave-active.hi-select-dropdown-placement-bottomLeft{-webkit-animation-name:antSlideUpOut;animation-name:antSlideUpOut}.hi-select-dropdown.slide-up-leave.slide-up-leave-active.hi-select-dropdown-placement-topLeft{-webkit-animation-name:antSlideDownOut;animation-name:antSlideDownOut}.hi-select-dropdown-hidden{display:none}.hi-select-dropdown-menu{outline:0;margin-bottom:0;padding-left:0;list-style:none;max-height:250px;overflow:auto}.hi-select-dropdown-menu-item-group-list{margin:0;padding:0}.hi-select-dropdown-menu-item-group-list>.hi-select-dropdown-menu-item{padding-left:20px}.hi-select-dropdown-menu-item-group-title{color:rgba(0,0,0,.45);padding:0 12px;height:32px;line-height:32px;font-size:12px}.hi-select-dropdown-menu-item{position:relative;display:block;padding:5px 12px;line-height:22px;font-weight:400;color:rgba(0,0,0,.65);white-space:nowrap;cursor:pointer;overflow:hidden;text-overflow:ellipsis;-webkit-transition:background .3s ease;transition:background .3s ease}.hi-select-dropdown-menu-item:hover{background-color:#e6fde8}.hi-select-dropdown-menu-item:first-child{border-radius:4px 4px 0 0}.hi-select-dropdown-menu-item:last-child{border-radius:0 0 4px 4px}.hi-select-dropdown-menu-item-disabled{color:rgba(0,0,0,.25);cursor:not-allowed}.hi-select-dropdown-menu-item-disabled:hover{color:rgba(0,0,0,.25);background-color:#fff;cursor:not-allowed}.hi-select-dropdown-menu-item-selected,.hi-select-dropdown-menu-item-selected:hover{background-color:#fafafa;font-weight:600;color:rgba(0,0,0,.65)}.hi-select-dropdown-menu-item-active{background-color:#e6f7ff}.hi-select-dropdown-menu-item-divider{height:1px;margin:1px 0;overflow:hidden;background-color:#e8e8e8;line-height:0}.hi-select-dropdown.hi-select-dropdown--multiple .hi-select-dropdown-menu-item:after{font-family:anticon;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale;content:\"\\E632\";color:transparent;display:inline-block;font-size:12px;font-size:10px\\9;-webkit-transform:scale(.83333) rotate(0);-ms-transform:scale(.83333) rotate(0);transform:scale(.83333) rotate(0);-webkit-transition:all .2s ease;transition:all .2s ease;position:absolute;top:50%;-webkit-transform:translateY(-50%);-ms-transform:translateY(-50%);transform:translateY(-50%);right:12px;font-weight:700;text-shadow:0 .1px 0,.1px 0 0,0 -.1px 0,-.1px 0}:root .hi-select-dropdown.hi-select-dropdown--multiple .hi-select-dropdown-menu-item:after{font-size:12px}.hi-select-dropdown.hi-select-dropdown--multiple .hi-select-dropdown-menu-item:hover:after{color:#ddd}.hi-select-dropdown.hi-select-dropdown--multiple .hi-select-dropdown-menu-item-disabled:after{display:none}.hi-select-dropdown.hi-select-dropdown--multiple .hi-select-dropdown-menu-item-selected:after,.hi-select-dropdown.hi-select-dropdown--multiple .hi-select-dropdown-menu-item-selected:hover:after{color:#28a745;display:inline-block}.hi-select-dropdown-container-open .hi-select-dropdown,.hi-select-dropdown-open .hi-select-dropdown{display:block}\n    "],
            encapsulation: ViewEncapsulation.None,
        }),
        __metadata("design:paramtypes", [Renderer2])
    ], SelectComponent);
    return SelectComponent;
}());
export { SelectComponent };
