var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ChangeDetectionStrategy, forwardRef, ChangeDetectorRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { HiNGConfig } from '../hi.config';
var SwitchComponent = (function () {
    function SwitchComponent(hiNGConfig, changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.onText = hiNGConfig.switchBtn.onText;
        this.offText = hiNGConfig.switchBtn.offText;
        this.type = hiNGConfig.switchBtn.type;
    }
    SwitchComponent_1 = SwitchComponent;
    SwitchComponent.prototype.toggle = function () {
        if (this.disabled) {
            return;
        }
        this.onTouched();
        this.checked = !this.checked;
        this.onChange(this.checked);
    };
    SwitchComponent.prototype.writeValue = function (obj) {
        this.checked = obj;
        this.changeDetectorRef.markForCheck();
    };
    SwitchComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    SwitchComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    SwitchComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    var SwitchComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SwitchComponent.prototype, "type", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SwitchComponent.prototype, "size", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], SwitchComponent.prototype, "disabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SwitchComponent.prototype, "onText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SwitchComponent.prototype, "offText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], SwitchComponent.prototype, "cssClass", void 0);
    SwitchComponent = SwitchComponent_1 = __decorate([
        Component({
            selector: 'hi-switch',
            template: "\n    <div class=\"switch {{cssClass}} {{size ? 'btn-' + size : ''}}\" (click)=\"toggle()\" [ngClass]=\"{'disabled': disabled}\"><span class=\"switch-left {{checked ? 'bg-'+ type + ' active' : ''}}\">{{onText}} </span><span class=\"switch-right {{!checked ? 'bg-'+ type + ' active' : ''}}\">{{offText}}</span></div>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return SwitchComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [HiNGConfig, ChangeDetectorRef])
    ], SwitchComponent);
    return SwitchComponent;
}());
export { SwitchComponent };
