var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, QueryList, ContentChildren, Input, Output, EventEmitter } from '@angular/core';
import { TabComponent } from './tab.component';
import { HiNGConfig } from '../hi.config';
var TabsComponent = (function () {
    function TabsComponent(hiNGConfig) {
        this.type = 'tabs';
        this.activeTabChange = new EventEmitter();
        this.type = hiNGConfig.tabs.type;
        this.justified = hiNGConfig.tabs.justified;
        this.vertical = hiNGConfig.tabs.vertical;
    }
    TabsComponent.prototype.ngAfterContentInit = function () {
        if (!this.activeTab && this.tabs.length) {
            this.select(this.tabs.first.id);
        }
    };
    TabsComponent.prototype.select = function (id) {
        var tab = this.tabs.find(function (item) { return item.id === id; });
        if (tab && !tab.disabled) {
            this.activeTab = id;
            this.activeTabChange.emit(id);
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TabsComponent.prototype, "type", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TabsComponent.prototype, "activeTab", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], TabsComponent.prototype, "vertical", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], TabsComponent.prototype, "justified", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TabsComponent.prototype, "cssClass", void 0);
    __decorate([
        ContentChildren(TabComponent),
        __metadata("design:type", QueryList)
    ], TabsComponent.prototype, "tabs", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], TabsComponent.prototype, "activeTabChange", void 0);
    TabsComponent = __decorate([
        Component({
            selector: 'hi-tabs',
            template: "\n    <ul class=\"nav nav-{{type}} {{cssClass}}\" [ngClass]=\"{'nav-stacked': vertical,'nav-justified': justified}\" role=\"tablist\"><li class=\"nav-item\" *ngFor=\"let tab of tabs\"><a class=\"nav-link\" role=\"tab\" (click)=\"select(tab.id)\" [class.active]=\"tab.id == activeTab\" data-toggle=\"tab\" [attr.aria-expanded]=\"tab.id == activeTab\"><i class=\"{{tab.icon}}\"></i><ng-template *ngIf=\"!tab.title\" [ngTemplateOutlet]=\"tab.titleTpl?.templateRef\"></ng-template>{{tab.title}}</a></li></ul><div class=\"tab-content\"><ng-container *ngFor=\"let tab of tabs\"><div class=\"tab-pane\" role=\"tabcard\" [ngClass]=\"{'in active': tab.id == activeTab}\"><ng-template [ngTemplateOutlet]=\"tab?.contentTpl?.templateRef\"></ng-template>{{tab.content}}</div></ng-container></div>\n  ",
            exportAs: 'tabs'
        }),
        __metadata("design:paramtypes", [HiNGConfig])
    ], TabsComponent);
    return TabsComponent;
}());
export { TabsComponent };
