var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, Input } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { HiNGConfig } from '../hi.config';
var TagsComponent = (function () {
    function TagsComponent(rebirthNGConfig) {
        this.rebirthNGConfig = rebirthNGConfig;
        this.mutipleItems = [];
        this.onChange = function (_) { return null; };
        this.onTouched = function () { return null; };
        this.type = this.rebirthNGConfig.tags.type;
        this.newTagText = this.rebirthNGConfig.tags.newTagText;
        this.plusIcon = this.rebirthNGConfig.tags.plusIcon;
        this.removeIcon = this.rebirthNGConfig.tags.removeIcon;
        this.maxlength = this.rebirthNGConfig.tags.maxlength;
        this.maxSize = this.rebirthNGConfig.tags.maxSize;
    }
    TagsComponent_1 = TagsComponent;
    TagsComponent.prototype.writeValue = function (obj) {
        this.mutipleItems = typeof obj === 'string' ? [obj] : (obj || []);
    };
    TagsComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    TagsComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    TagsComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    TagsComponent.prototype.newTag = function () {
        if (this.canAddMore()) {
            this.isTyping = true;
        }
    };
    TagsComponent.prototype.removeLabel = function (label) {
        this.mutipleItems = this.mutipleItems.filter(function (item) { return label !== item; });
        this.onTouched();
        this.onChange(this.mutipleItems);
    };
    TagsComponent.prototype.addLabel = function (label) {
        this.onTouched();
        if (label && this.mutipleItems.indexOf(label) === -1 && this.canAddMore()) {
            this.mutipleItems.push(label);
            this.onChange(this.mutipleItems);
        }
        this.selectValue = '';
        this.isTyping = false;
    };
    TagsComponent.prototype.canAddMore = function () {
        return !this.maxSize || this.mutipleItems.length < this.maxSize;
    };
    TagsComponent.prototype.boxBlur = function (label) {
        this.addLabel(label);
    };
    var TagsComponent_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TagsComponent.prototype, "cssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TagsComponent.prototype, "newTagText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TagsComponent.prototype, "plusIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TagsComponent.prototype, "removeIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], TagsComponent.prototype, "maxlength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], TagsComponent.prototype, "maxSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TagsComponent.prototype, "type", void 0);
    TagsComponent = TagsComponent_1 = __decorate([
        Component({
            selector: 'hi-tags',
            template: "\n    <ul class=\"tags {{cssClass}}\"><li *ngFor=\"let item of mutipleItems\" class=\"tag-item\"><span class=\"label label-{{type}} tag\" [ngClass]=\"{disabled: disabled}\">{{item}}<i aria-hidden=\"true\" class=\"label-btn label-remove {{removeIcon}}\" *ngIf=\"!disabled\" (click)=\"removeLabel(item)\"></i></span></li><li *ngIf=\"!disabled && !isTyping\" (click)=\"newTag()\" class=\"new-tag-item\"><button class=\"btn label label-{{type}} btn-new-tag\" [disabled]=\"!canAddMore()\">{{newTagText}}<i aria-hidden=\"true\" class=\"label-btn label-plus {{plusIcon}}\"></i></button></li><li *ngIf=\"!disabled && isTyping\" class=\"tag-input-panel\"><input [hiAutoFocus]=\"isTyping\" name=\"tagsInput\" class=\"form-control tag-input-control\" [maxlength]=\"maxlength\" [(ngModel)]=\"selectValue\" (keydown.enter)=\"addLabel(selectValue)\" (blur)=\"boxBlur(selectValue)\"></li></ul>\n  ",
            exportAs: 'tags',
            providers: [{
                    provide: NG_VALUE_ACCESSOR,
                    useExisting: forwardRef(function () { return TagsComponent_1; }),
                    multi: true
                }]
        }),
        __metadata("design:paramtypes", [HiNGConfig])
    ], TagsComponent);
    return TagsComponent;
}());
export { TagsComponent };
