import { ChangeDetectorRef, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export declare class TimePickerModel {
    hour: number;
    minute: number;
    second?: number;
    constructor(hour: number, minute: number, second?: number);
    toString(): string;
}
export declare const TIME_UNIT: {
    HOUR: string;
    MINUTE: string;
    SECOND: string;
};
export declare const MAX_TIME_RANGE: {
    hour: number;
    minute: number;
    second: number;
};
export declare class TimePickerComponent implements OnInit, ControlValueAccessor {
    private changeDetectorRef;
    showSeconds: boolean;
    minTime: TimePickerModel;
    maxTime: TimePickerModel;
    hour: string;
    minute: string;
    second: string;
    timeUnit: {
        HOUR: string;
        MINUTE: string;
        SECOND: string;
    };
    minDate: Date;
    maxDate: Date;
    disabled: boolean;
    private onChange;
    private onTouched;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    initConditionDate(): void;
    getDateByTime(time: TimePickerModel): Date;
    getValue(value: any, defaultValue: any): any;
    getCurrentTimestamp(time: any): number;
    writeValue(value: TimePickerModel): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(disabled: any): void;
    updateTimeByMargin(key: string, marginDate: any): void;
    modifyTimeByKey(value: number, key: string): void;
    onTimeChange(key: string): void;
    onModelChange(): void;
    private getTimePickerModel;
    isSafetyKeyPress(keyType: any, target: string, key: string): boolean;
    isSupportedKeyPress(event: any): boolean;
    handleKeyEvent(event: any, type: any): void;
    modifyTimeByKeyPress(key: string, type: string, step: number): void;
    modifyTimeByKeyPressEvent(type: string, keyEventType: string): void;
}
