var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { CdkConnectedOverlay } from '@angular/cdk/overlay';
import { ChangeDetectorRef, Component, ContentChild, EventEmitter, Input, Output, TemplateRef, ViewChild, ViewEncapsulation } from '@angular/core';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { fadeAnimation } from '../common/animation/fade-animations';
import { DEFAULT_4_POSITIONS, POSITION_MAP } from '../common/overlay/overlay-position-map';
import { toBoolean } from '../utils/convert';
var TooltipComponent = (function () {
    function TooltipComponent(_cdr) {
        this._cdr = _cdr;
        this._hasBackdrop = false;
        this.hiOverlayClassName = '';
        this.hiOverlayStyle = {};
        this.hiMouseEnterDelay = 0.15;
        this.hiMouseLeaveDelay = 0.1;
        this.hiVisibleChange = new EventEmitter();
        this.visibleSource = new BehaviorSubject(false);
        this.visible$ = this.visibleSource.asObservable();
        this._prefix = 'hi-tooltip-placement';
        this._positions = DEFAULT_4_POSITIONS.slice();
        this._classMap = {};
        this._placement = 'top';
        this._trigger = 'hover';
    }
    Object.defineProperty(TooltipComponent.prototype, "hiVisible", {
        get: function () {
            return this.visibleSource.value;
        },
        set: function (value) {
            var visible = toBoolean(value);
            if (this.visibleSource.value !== visible) {
                this.visibleSource.next(visible);
                this.hiVisibleChange.emit(visible);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TooltipComponent.prototype, "hiTrigger", {
        get: function () {
            return this._trigger;
        },
        set: function (value) {
            this._trigger = value;
            this._hasBackdrop = this._trigger === 'click';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TooltipComponent.prototype, "hiPlacement", {
        get: function () {
            return this._placement;
        },
        set: function (value) {
            if (value !== this._placement) {
                this._placement = value;
                this._positions.unshift(POSITION_MAP[this.hiPlacement]);
            }
        },
        enumerable: true,
        configurable: true
    });
    TooltipComponent.prototype.updatePosition = function () {
        if (this.overlay && this.overlay.overlayRef) {
            this.overlay.overlayRef.updatePosition();
        }
    };
    TooltipComponent.prototype.onPositionChange = function ($event) {
        for (var key in POSITION_MAP) {
            if (JSON.stringify($event.connectionPair) === JSON.stringify(POSITION_MAP[key])) {
                this.hiPlacement = key;
                break;
            }
        }
        this.setClassMap();
        this._cdr.detectChanges();
    };
    TooltipComponent.prototype.show = function () {
        if (!this.isContentEmpty()) {
            this.hiVisible = true;
        }
    };
    TooltipComponent.prototype.hide = function () {
        this.hiVisible = false;
    };
    TooltipComponent.prototype._afterVisibilityAnimation = function (e) {
        if (e.toState === 'false' && !this.hiVisible) {
            this.hiVisibleChange.emit(false);
        }
        if (e.toState === 'true' && this.hiVisible) {
            this.hiVisibleChange.emit(true);
        }
    };
    TooltipComponent.prototype.setClassMap = function () {
        var _a;
        this._classMap = (_a = {},
            _a[this.hiOverlayClassName] = true,
            _a[this._prefix + "-" + this._placement] = true,
            _a);
    };
    TooltipComponent.prototype.setOverlayOrigin = function (origin) {
        this.overlayOrigin = origin;
    };
    TooltipComponent.prototype.isContentEmpty = function () {
        return (this.hiTemplate || this.hiContent) ? false : (this.hiTitle === '' || this.hiTitle == null);
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], TooltipComponent.prototype, "hiTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TooltipComponent.prototype, "hiContent", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TooltipComponent.prototype, "hiOverlayClassName", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TooltipComponent.prototype, "hiOverlayStyle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TooltipComponent.prototype, "hiMouseEnterDelay", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TooltipComponent.prototype, "hiMouseLeaveDelay", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], TooltipComponent.prototype, "hiVisibleChange", void 0);
    __decorate([
        ContentChild('hiTemplate', { static: false }),
        __metadata("design:type", TemplateRef)
    ], TooltipComponent.prototype, "hiTemplate", void 0);
    __decorate([
        ViewChild('overlay', { static: false }),
        __metadata("design:type", CdkConnectedOverlay)
    ], TooltipComponent.prototype, "overlay", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], TooltipComponent.prototype, "hiVisible", null);
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], TooltipComponent.prototype, "hiTrigger", null);
    __decorate([
        Input(),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], TooltipComponent.prototype, "hiPlacement", null);
    TooltipComponent = __decorate([
        Component({
            selector: 'hi-tooltip',
            preserveWhitespaces: false,
            animations: [fadeAnimation],
            template: "\n    <ng-content></ng-content><ng-template #overlay=\"cdkConnectedOverlay\" cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"overlayOrigin\" [cdkConnectedOverlayHasBackdrop]=\"_hasBackdrop\" (backdropClick)=\"hide()\" (detach)=\"hide()\" (positionChange)=\"onPositionChange($event)\" [cdkConnectedOverlayPositions]=\"_positions\" [cdkConnectedOverlayOpen]=\"visible$ | async\"><div class=\"hi-tooltip\" [ngClass]=\"_classMap\" [ngStyle]=\"hiOverlayStyle\" [@fadeAnimation]=\"''+(visible$ | async)\" (@fadeAnimation.done)=\"_afterVisibilityAnimation($event)\"><div class=\"hi-tooltip-content\"><div class=\"hi-tooltip-arrow\"></div><div class=\"hi-tooltip-inner\"><span *ngIf=\"!hiTemplate\">{{ hiTitle }}</span><ng-template *ngIf=\"hiTemplate\" [ngTemplateOutlet]=\"hiTemplate\"></ng-template></div></div></div></ng-template>\n  ",
            styles: ["\n    .cdk-overlay-container{pointer-events:none;top:0;left:0;height:100%;width:100%;position:fixed;z-index:1000}.cdk-overlay-backdrop{top:0;bottom:0;left:0;right:0;-webkit-tap-highlight-color:transparent;-webkit-transition:opacity .4s cubic-bezier(.25,.8,.25,1);transition:opacity .4s cubic-bezier(.25,.8,.25,1);opacity:0}.cdk-overlay-backdrop,.cdk-overlay-pane{position:absolute;pointer-events:auto;z-index:1000}.hi-tooltip{font-family:\"Monospaced Number\",\"Chinese Quote\",-apple-system,BlinkMacSystemFont,\"Segoe UI\",Roboto,\"PingFang SC\",\"Hiragino Sans GB\",\"Microsoft YaHei\",\"Helvetica Neue\",Helvetica,Arial,sans-serif;font-size:14px;line-height:1.5;color:rgba(0,0,0,.65);-webkit-box-sizing:border-box;box-sizing:border-box;margin:0;padding:0;list-style:none;position:relative;z-index:1060;display:block;visibility:visible}.hi-tooltip-hidden{display:none}.hi-tooltip-placement-top,.hi-tooltip-placement-topLeft,.hi-tooltip-placement-topRight{padding-bottom:8px}.hi-tooltip-placement-right,.hi-tooltip-placement-rightBottom,.hi-tooltip-placement-rightTop{padding-left:8px}.hi-tooltip-placement-bottom,.hi-tooltip-placement-bottomLeft,.hi-tooltip-placement-bottomRight{padding-top:8px}.hi-tooltip-placement-left,.hi-tooltip-placement-leftBottom,.hi-tooltip-placement-leftTop{padding-right:8px}.hi-tooltip-inner{max-width:250px;padding:6px 8px;color:#fff;text-align:left;text-decoration:none;background-color:rgba(0,0,0,.75);border-radius:4px;-webkit-box-shadow:0 2px 8px rgba(0,0,0,.15);box-shadow:0 2px 8px rgba(0,0,0,.15);min-height:32px}.hi-tooltip-arrow{position:absolute;width:0;height:0;border-color:transparent;border-style:solid}.hi-tooltip-placement-top .hi-tooltip-arrow,.hi-tooltip-placement-topLeft .hi-tooltip-arrow,.hi-tooltip-placement-topRight .hi-tooltip-arrow{bottom:3px;border-width:5px 5px 0;border-top-color:rgba(0,0,0,.75)}.hi-tooltip-placement-top .hi-tooltip-arrow{left:50%;margin-left:-5px}.hi-tooltip-placement-topLeft .hi-tooltip-arrow{left:16px}.hi-tooltip-placement-topRight .hi-tooltip-arrow{right:16px}.hi-tooltip-placement-right .hi-tooltip-arrow,.hi-tooltip-placement-rightBottom .hi-tooltip-arrow,.hi-tooltip-placement-rightTop .hi-tooltip-arrow{left:3px;border-width:5px 5px 5px 0;border-right-color:rgba(0,0,0,.75)}.hi-tooltip-placement-right .hi-tooltip-arrow{top:50%;margin-top:-5px}.hi-tooltip-placement-rightTop .hi-tooltip-arrow{top:8px}.hi-tooltip-placement-rightBottom .hi-tooltip-arrow{bottom:8px}.hi-tooltip-placement-left .hi-tooltip-arrow,.hi-tooltip-placement-leftBottom .hi-tooltip-arrow,.hi-tooltip-placement-leftTop .hi-tooltip-arrow{right:3px;border-width:5px 0 5px 5px;border-left-color:rgba(0,0,0,.75)}.hi-tooltip-placement-left .hi-tooltip-arrow{top:50%;margin-top:-5px}.hi-tooltip-placement-leftTop .hi-tooltip-arrow{top:8px}.hi-tooltip-placement-leftBottom .hi-tooltip-arrow{bottom:8px}.hi-tooltip-placement-bottom .hi-tooltip-arrow,.hi-tooltip-placement-bottomLeft .hi-tooltip-arrow,.hi-tooltip-placement-bottomRight .hi-tooltip-arrow{top:3px;border-width:0 5px 5px;border-bottom-color:rgba(0,0,0,.75)}.hi-tooltip-placement-bottom .hi-tooltip-arrow{left:50%;margin-left:-5px}.hi-tooltip-placement-bottomLeft .hi-tooltip-arrow{left:16px}.hi-tooltip-placement-bottomRight .hi-tooltip-arrow{right:16px}\n  "],
            encapsulation: ViewEncapsulation.None,
        }),
        __metadata("design:paramtypes", [ChangeDetectorRef])
    ], TooltipComponent);
    return TooltipComponent;
}());
export { TooltipComponent };
