var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { ComponentFactoryResolver, Directive, ElementRef, HostBinding, Input, Optional, Renderer2, ViewContainerRef } from '@angular/core';
import { TooltipComponent } from './tooltip.component';
var TooltipDirective = (function () {
    function TooltipDirective(elementRef, hostView, resolver, renderer, tooltip) {
        this.elementRef = elementRef;
        this.hostView = hostView;
        this.resolver = resolver;
        this.renderer = renderer;
        this.isDynamicTooltip = false;
        this.tooltip = tooltip;
        if (!this.tooltip) {
            var factory = this.resolver.resolveComponentFactory(TooltipComponent);
            this.tooltip = this.hostView.createComponent(factory).instance;
            this.isDynamicTooltip = true;
        }
        this.tooltip.setOverlayOrigin(this);
    }
    Object.defineProperty(TooltipDirective.prototype, "hiTitle", {
        set: function (title) {
            if (this.isDynamicTooltip) {
                this.tooltip.hiTitle = title;
            }
        },
        enumerable: true,
        configurable: true
    });
    TooltipDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.tooltip.hiTrigger === 'hover') {
            var overlayElement_1;
            this.renderer.listen(this.elementRef.nativeElement, 'mouseenter', function () { return _this.delayEnterLeave(true, true, _this.tooltip.hiMouseEnterDelay); });
            this.renderer.listen(this.elementRef.nativeElement, 'mouseleave', function () {
                _this.delayEnterLeave(true, false, _this.tooltip.hiMouseLeaveDelay);
                if (_this.tooltip.overlay.overlayRef && !overlayElement_1) {
                    overlayElement_1 = _this.tooltip.overlay.overlayRef.overlayElement;
                    _this.renderer.listen(overlayElement_1, 'mouseenter', function () { return _this.delayEnterLeave(false, true); });
                    _this.renderer.listen(overlayElement_1, 'mouseleave', function () { return _this.delayEnterLeave(false, false); });
                }
            });
        }
        else if (this.tooltip.hiTrigger === 'focus') {
            this.renderer.listen(this.elementRef.nativeElement, 'focus', function () { return _this.show(); });
            this.renderer.listen(this.elementRef.nativeElement, 'blur', function () { return _this.hide(); });
        }
        else if (this.tooltip.hiTrigger === 'click') {
            this.renderer.listen(this.elementRef.nativeElement, 'click', function (e) {
                e.preventDefault();
                _this.show();
            });
        }
    };
    TooltipDirective.prototype.show = function () {
        this.tooltip.show();
        this.isTooltipOpen = true;
    };
    TooltipDirective.prototype.hide = function () {
        this.tooltip.hide();
        this.isTooltipOpen = false;
    };
    TooltipDirective.prototype.delayEnterLeave = function (isOrigin, isEnter, delay) {
        var _this = this;
        if (delay === void 0) { delay = -1; }
        if (this.delayTimer) {
            window.clearTimeout(this.delayTimer);
            this.delayTimer = null;
        }
        else if (delay > 0) {
            this.delayTimer = window.setTimeout(function () {
                _this.delayTimer = null;
                isEnter ? _this.show() : _this.hide();
            }, delay * 1000);
        }
        else {
            isEnter && isOrigin ? this.show() : this.hide();
        }
    };
    __decorate([
        Input('hi-tooltip'),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [String])
    ], TooltipDirective.prototype, "hiTitle", null);
    __decorate([
        HostBinding('class.hi-tooltip-open'),
        __metadata("design:type", Object)
    ], TooltipDirective.prototype, "isTooltipOpen", void 0);
    TooltipDirective = __decorate([
        Directive({
            selector: '[hi-tooltip]'
        }),
        __param(4, Optional()),
        __metadata("design:paramtypes", [ElementRef,
            ViewContainerRef,
            ComponentFactoryResolver,
            Renderer2,
            TooltipComponent])
    ], TooltipDirective);
    return TooltipDirective;
}());
export { TooltipDirective };
