import { coerceBooleanProperty, coerceNumberProperty } from '@angular/cdk/coercion';
export function toBoolean(value) {
    return coerceBooleanProperty(value);
}
export function toNumber(value, fallback) {
    return coerceNumberProperty(value, fallback);
}
export function InputBoolean() {
    return function InputBooleanPropDecorator(target, name) {
        var privatePropName = "$$__" + name;
        if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
            console.warn("The prop \"" + privatePropName + "\" is already exist, it will be overrided by InputBoolean decorator.");
        }
        Object.defineProperty(target, privatePropName, {
            configurable: true,
            writable: true
        });
        Object.defineProperty(target, name, {
            get: function () {
                return this[privatePropName];
            },
            set: function (value) {
                this[privatePropName] = toBoolean(value);
            }
        });
    };
}
