var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Directive, Inject, Input, LOCALE_ID } from '@angular/core';
import { NG_VALIDATORS } from '@angular/forms';
import { includesValidator, equalToValidator, rangeLengthValidator, minValidator, maxValidator, rangeValidator, digitsValidator, numberValidator, urlValidator, emailValidator, dateValidator, dateISOValidator, jsonValidator, base64Validator, phoneValidator, uuidValidator, equalValidator, beforeDateValidator, afterDateValidator, requiredWithTrim } from './validators';
var RequiredWithTrimDirective = (function () {
    function RequiredWithTrimDirective() {
    }
    RequiredWithTrimDirective_1 = RequiredWithTrimDirective;
    RequiredWithTrimDirective.prototype.validate = function (control) {
        return requiredWithTrim(control);
    };
    var RequiredWithTrimDirective_1;
    RequiredWithTrimDirective = RequiredWithTrimDirective_1 = __decorate([
        Directive({
            selector: '[hiRequiredWithTrim]',
            providers: [{ provide: NG_VALIDATORS, useExisting: RequiredWithTrimDirective_1, multi: true }]
        })
    ], RequiredWithTrimDirective);
    return RequiredWithTrimDirective;
}());
export { RequiredWithTrimDirective };
var RangeLengthDirective = (function () {
    function RangeLengthDirective() {
    }
    RangeLengthDirective_1 = RangeLengthDirective;
    RangeLengthDirective.prototype.validate = function (control) {
        return rangeLengthValidator(this.hiRangeLength)(control);
    };
    var RangeLengthDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], RangeLengthDirective.prototype, "hiRangeLength", void 0);
    RangeLengthDirective = RangeLengthDirective_1 = __decorate([
        Directive({
            selector: '[hiRangeLength]',
            providers: [{ provide: NG_VALIDATORS, useExisting: RangeLengthDirective_1, multi: true }]
        })
    ], RangeLengthDirective);
    return RangeLengthDirective;
}());
export { RangeLengthDirective };
var MinDirective = (function () {
    function MinDirective() {
    }
    MinDirective_1 = MinDirective;
    MinDirective.prototype.validate = function (control) {
        return minValidator(this.hiMin)(control);
    };
    var MinDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MinDirective.prototype, "hiMin", void 0);
    MinDirective = MinDirective_1 = __decorate([
        Directive({
            selector: '[hiMin]',
            providers: [{ provide: NG_VALIDATORS, useExisting: MinDirective_1, multi: true }]
        })
    ], MinDirective);
    return MinDirective;
}());
export { MinDirective };
var MaxDirective = (function () {
    function MaxDirective() {
    }
    MaxDirective_1 = MaxDirective;
    MaxDirective.prototype.validate = function (control) {
        return maxValidator(this.hiMax)(control);
    };
    var MaxDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], MaxDirective.prototype, "hiMax", void 0);
    MaxDirective = MaxDirective_1 = __decorate([
        Directive({
            selector: '[hiMax]',
            providers: [{ provide: NG_VALIDATORS, useExisting: MaxDirective_1, multi: true }]
        })
    ], MaxDirective);
    return MaxDirective;
}());
export { MaxDirective };
var RangeDirective = (function () {
    function RangeDirective() {
    }
    RangeDirective_1 = RangeDirective;
    RangeDirective.prototype.validate = function (control) {
        return rangeValidator(this.hiRange)(control);
    };
    var RangeDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], RangeDirective.prototype, "hiRange", void 0);
    RangeDirective = RangeDirective_1 = __decorate([
        Directive({
            selector: '[hiRange]',
            providers: [{ provide: NG_VALIDATORS, useExisting: RangeDirective_1, multi: true }]
        })
    ], RangeDirective);
    return RangeDirective;
}());
export { RangeDirective };
var DigitsDirective = (function () {
    function DigitsDirective() {
    }
    DigitsDirective_1 = DigitsDirective;
    DigitsDirective.prototype.validate = function (control) {
        return digitsValidator()(control);
    };
    var DigitsDirective_1;
    DigitsDirective = DigitsDirective_1 = __decorate([
        Directive({
            selector: '[hiDigits]',
            providers: [{ provide: NG_VALIDATORS, useExisting: DigitsDirective_1, multi: true }]
        })
    ], DigitsDirective);
    return DigitsDirective;
}());
export { DigitsDirective };
var NumberDirective = (function () {
    function NumberDirective() {
    }
    NumberDirective_1 = NumberDirective;
    NumberDirective.prototype.validate = function (control) {
        return numberValidator()(control);
    };
    var NumberDirective_1;
    NumberDirective = NumberDirective_1 = __decorate([
        Directive({
            selector: '[hiNumber]',
            providers: [{ provide: NG_VALIDATORS, useExisting: NumberDirective_1, multi: true }]
        })
    ], NumberDirective);
    return NumberDirective;
}());
export { NumberDirective };
var UrlDirective = (function () {
    function UrlDirective() {
    }
    UrlDirective_1 = UrlDirective;
    UrlDirective.prototype.validate = function (control) {
        return urlValidator()(control);
    };
    var UrlDirective_1;
    UrlDirective = UrlDirective_1 = __decorate([
        Directive({
            selector: '[hiUrl]',
            providers: [{ provide: NG_VALIDATORS, useExisting: UrlDirective_1, multi: true }]
        })
    ], UrlDirective);
    return UrlDirective;
}());
export { UrlDirective };
var EmailDirective = (function () {
    function EmailDirective() {
    }
    EmailDirective_1 = EmailDirective;
    EmailDirective.prototype.validate = function (control) {
        return emailValidator()(control);
    };
    var EmailDirective_1;
    EmailDirective = EmailDirective_1 = __decorate([
        Directive({
            selector: '[hiEmail]',
            providers: [{ provide: NG_VALIDATORS, useExisting: EmailDirective_1, multi: true }]
        })
    ], EmailDirective);
    return EmailDirective;
}());
export { EmailDirective };
var DateDirective = (function () {
    function DateDirective() {
    }
    DateDirective_1 = DateDirective;
    DateDirective.prototype.validate = function (control) {
        return dateValidator()(control);
    };
    var DateDirective_1;
    DateDirective = DateDirective_1 = __decorate([
        Directive({
            selector: '[hiDate]',
            providers: [{ provide: NG_VALIDATORS, useExisting: DateDirective_1, multi: true }]
        })
    ], DateDirective);
    return DateDirective;
}());
export { DateDirective };
var DateISODirective = (function () {
    function DateISODirective() {
    }
    DateISODirective_1 = DateISODirective;
    DateISODirective.prototype.validate = function (control) {
        return dateISOValidator()(control);
    };
    var DateISODirective_1;
    DateISODirective = DateISODirective_1 = __decorate([
        Directive({
            selector: '[hiDateISO]',
            providers: [{ provide: NG_VALIDATORS, useExisting: DateISODirective_1, multi: true }]
        })
    ], DateISODirective);
    return DateISODirective;
}());
export { DateISODirective };
var JsonDirective = (function () {
    function JsonDirective() {
    }
    JsonDirective_1 = JsonDirective;
    JsonDirective.prototype.validate = function (control) {
        return jsonValidator()(control);
    };
    var JsonDirective_1;
    JsonDirective = JsonDirective_1 = __decorate([
        Directive({
            selector: '[hiJson]',
            providers: [{ provide: NG_VALIDATORS, useExisting: JsonDirective_1, multi: true }]
        })
    ], JsonDirective);
    return JsonDirective;
}());
export { JsonDirective };
var Base64Directive = (function () {
    function Base64Directive() {
    }
    Base64Directive_1 = Base64Directive;
    Base64Directive.prototype.validate = function (control) {
        return base64Validator()(control);
    };
    var Base64Directive_1;
    Base64Directive = Base64Directive_1 = __decorate([
        Directive({
            selector: '[hiBase64]',
            providers: [{ provide: NG_VALIDATORS, useExisting: Base64Directive_1, multi: true }]
        })
    ], Base64Directive);
    return Base64Directive;
}());
export { Base64Directive };
var PhoneDirective = (function () {
    function PhoneDirective(locale) {
        this.locale = locale;
    }
    PhoneDirective_1 = PhoneDirective;
    PhoneDirective.prototype.validate = function (control) {
        return phoneValidator(this.hiPhone || this.locale)(control);
    };
    var PhoneDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PhoneDirective.prototype, "hiPhone", void 0);
    PhoneDirective = PhoneDirective_1 = __decorate([
        Directive({
            selector: '[hiPhone]',
            providers: [{ provide: NG_VALIDATORS, useExisting: PhoneDirective_1, multi: true }]
        }),
        __param(0, Inject(LOCALE_ID)),
        __metadata("design:paramtypes", [String])
    ], PhoneDirective);
    return PhoneDirective;
}());
export { PhoneDirective };
var UUIDDirective = (function () {
    function UUIDDirective() {
    }
    UUIDDirective_1 = UUIDDirective;
    UUIDDirective.prototype.validate = function (control) {
        return uuidValidator()(control);
    };
    var UUIDDirective_1;
    UUIDDirective = UUIDDirective_1 = __decorate([
        Directive({
            selector: '[hiUUID]',
            providers: [{ provide: NG_VALIDATORS, useExisting: UUIDDirective_1, multi: true }]
        })
    ], UUIDDirective);
    return UUIDDirective;
}());
export { UUIDDirective };
var EqualDirective = (function () {
    function EqualDirective() {
    }
    EqualDirective_1 = EqualDirective;
    EqualDirective.prototype.validate = function (control) {
        return equalValidator(this.hiEqual)(control);
    };
    var EqualDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], EqualDirective.prototype, "hiEqual", void 0);
    EqualDirective = EqualDirective_1 = __decorate([
        Directive({
            selector: '[hiEqual]',
            providers: [{ provide: NG_VALIDATORS, useExisting: EqualDirective_1, multi: true }]
        })
    ], EqualDirective);
    return EqualDirective;
}());
export { EqualDirective };
var IncludesDirective = (function () {
    function IncludesDirective() {
    }
    IncludesDirective_1 = IncludesDirective;
    IncludesDirective.prototype.validate = function (control) {
        return includesValidator(this.hiIncludes)(control);
    };
    var IncludesDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], IncludesDirective.prototype, "hiIncludes", void 0);
    IncludesDirective = IncludesDirective_1 = __decorate([
        Directive({
            selector: '[hiIncludes]',
            providers: [{ provide: NG_VALIDATORS, useExisting: IncludesDirective_1, multi: true }]
        })
    ], IncludesDirective);
    return IncludesDirective;
}());
export { IncludesDirective };
var EqualToDirective = (function () {
    function EqualToDirective() {
    }
    EqualToDirective_1 = EqualToDirective;
    Object.defineProperty(EqualToDirective.prototype, "hiEqualTo", {
        set: function (target) {
            this.validatorFn = equalToValidator(target);
        },
        enumerable: true,
        configurable: true
    });
    EqualToDirective.prototype.validate = function (control) {
        return this.validatorFn(control);
    };
    var EqualToDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], EqualToDirective.prototype, "hiEqualTo", null);
    EqualToDirective = EqualToDirective_1 = __decorate([
        Directive({
            selector: '[hiEqualTo]',
            providers: [{ provide: NG_VALIDATORS, useExisting: EqualToDirective_1, multi: true }]
        })
    ], EqualToDirective);
    return EqualToDirective;
}());
export { EqualToDirective };
var BeforeDateDirective = (function () {
    function BeforeDateDirective() {
    }
    BeforeDateDirective_1 = BeforeDateDirective;
    Object.defineProperty(BeforeDateDirective.prototype, "hiBeforeDate", {
        set: function (target) {
            this.validatorFn = beforeDateValidator(target);
        },
        enumerable: true,
        configurable: true
    });
    BeforeDateDirective.prototype.validate = function (control) {
        return this.validatorFn(control);
    };
    var BeforeDateDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], BeforeDateDirective.prototype, "hiBeforeDate", null);
    BeforeDateDirective = BeforeDateDirective_1 = __decorate([
        Directive({
            selector: '[hiBeforeDate]',
            providers: [{ provide: NG_VALIDATORS, useExisting: BeforeDateDirective_1, multi: true }]
        })
    ], BeforeDateDirective);
    return BeforeDateDirective;
}());
export { BeforeDateDirective };
var AfterDateDirective = (function () {
    function AfterDateDirective() {
    }
    AfterDateDirective_1 = AfterDateDirective;
    Object.defineProperty(AfterDateDirective.prototype, "hiAfterDate", {
        set: function (target) {
            this.validatorFn = afterDateValidator(target);
        },
        enumerable: true,
        configurable: true
    });
    AfterDateDirective.prototype.validate = function (control) {
        return this.validatorFn(control);
    };
    var AfterDateDirective_1;
    __decorate([
        Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], AfterDateDirective.prototype, "hiAfterDate", null);
    AfterDateDirective = AfterDateDirective_1 = __decorate([
        Directive({
            selector: '[hiAfterDate]',
            providers: [{ provide: NG_VALIDATORS, useExisting: AfterDateDirective_1, multi: true }]
        })
    ], AfterDateDirective);
    return AfterDateDirective;
}());
export { AfterDateDirective };
